-- $Name:Гиблые земли$
-- $Version:0.1$
-- $Author:NasPolkovnik, 2011$

--[[ 
	Все основные картинки размером 480х360. В некоторых случаях 
	картинки немного обрезаны по выcоте, чтобы снизу было 
	достаточно места под текст.

    Объекты, привязанные к сцене, имеют соответствующие префиксы.
]]

instead_version "1.5.0"

require "dash" 
require "quotes"
require "input"
require "click"
require "hideinv"
require "timer"	
require "xact"	

game.codepage = "UTF-8";
game.act = '<пропущен обработчик act>';
game.use = function()
	local reaction = {
		[1] = 'Не получится...',
		[2] = 'Мысль, конечно, интересная...',
		[3] = 'Надо попробовать что-нибудь ещё...',
	};
	return reaction[rnd(#reaction)];
end;

main = room {
	nam = 'Вместо предисловия';
	pic = 'gfx/intro/game_title.jpg';
	dsc = txtc("ГИБЛЫЕ ЗЕМЛИ")..[[
		^^
		Вашему вниманию представлен ]]..txtem('авторский')..[[ римейк игры 
		]]..txtb('"Гиблые земли. Город теней"')..[[ от компании Alawar Stargaze.
		Все права на графический материал и сюжет принадлежат 
		указанной компании. (Посмотреть основные {comments|изменения}.) 
		^^
		Оригинальную версию этой игры вы можете скачать по адресу:
		]]..txtu('http://www.alawar.ru/game/twisted-lands-shadow-town/')..[[
		^(требует регистрации после 30 минут игры)
		^^
		{start_game|Начать игру >>>} 
	]];
	obj = {
		xact('comments',   code[[goto(main_comments);]]),
		xact('start_game', code[[goto(coast_awake);]]),
	};
};

main_comments = room {
	nam = 'Изменения и особенности';
	dsc = [[
		Оригинальная игра "]]..txtb('Гиблые земли. Город теней')..[[",
		по которой сделан римейк, 
		относится к жанру adventure + hidden objects + puzzle, 
		поэтому при переносе в текстовый квест были сделаны 
		следующие изменения:^
		-- убраны все режимы "поиск предметов";^
		-- убран дневник ГГ и подсказка, куда дальше идти;^
		-- убрано задание "собери N статуэток";^
		-- сокращен сюжет (интригующая развязка осталась за бортом :).
		^^
		В целом:^
		-- реализовано примерно 2/3 оригинальной игры (50 основных локаций, 5 мини-игр);^
		-- слегка изменён облик ГГ (акценты на его деятельности как охотника за актиквариатом не ставятся);^
		-- немного изменена квестовая составляющая;^
		-- мини-игра сейф взята из игры "Шерлок Холмс и собака Баскервиллей";^
		-- большинство предметов пропадает из инвентаря, если они больше не нужны (особенность оригинальной игры).
		^^
		{back|Назад}
	]];
	obj = {
		xact('back', code[[goback();]])
	}
};

dofile('objects.lua');
dofile('part1.lua');
dofile('part2.lua');
dofile('part3.lua');
dofile('park.lua');
dofile('puzzle1.lua');
dofile('puzzle2.lua');
dofile('puzzle3.lua');
dofile('puzzle4.lua');
dofile('puzzle5.lua');

