-- ОБЪЕКТЫ, КОТОРЫЕ МОЖНО ПОМЕСТИТЬ В ИНВЕНТАРЬ
-- и некоторые общие функции

global {
	seen_animation = false,
	lock_code = rnd(1000) - 1,
};

-- единая функция инициализации для всех модулей
function init()
	print('------------')
	print('Exec: init()')
	init_zd_board()
end

-- в отличие от стандартного drop(o) не устанавливает o._taken = false
-- можно использовать для предметов, которые после сбрасывания больше
-- нельзя будет подобрать (абордажный крюк, зарядник)
function mydrop(o)
	remove(o, me())
	objs():add(o)
end

-- выводит сообщение из объекта s и переключает флаг s.msg_one
-- требует, чтобы var { msg_one = true } была объявлена внутри объекта s!
function p_12(s, text_1, text_2)
	if s.msg_one == nil then
		error("Error: flag 's.msg_one' is not defined!")
	end
	if s.msg_one then
		p(text_1)
	else
		p(text_2)
	end
	s.msg_one = not s.msg_one
end

--[[
-- questions не используется, интересность для геймплея пока не понятна
questions = obj {
	nam = 'вопросы';
	inv = function(s)
		p 'Меня мучают вопросы:'
		p '^-- Что это за место?'
		p '^-- Как я сюда попал?'
		p '^-- Где Энжел?'
		if seen_fragmentary_hole then
			p '^-- Что прорвало обшивку корабля изнутри?'
		end
		if seen_corridor then
			p '^-- Зачем нужно было устраивать баррикаду на корабле?'
		end
-- 		Откуда у церкви взялось мое фото с сестрой?
	end;
};
]]

flashlight = obj {
	nam = 'фонарик';
	inv = 'Обычный фонарик.';
};

notebook = obj {
	nam = 'ноутбук';
	-- константы состояний
	ST_START = 0;	-- нерабочее состояние (начальное)
	ST_PANEL = 1;	-- задняя панель открыта
	ST_MEMORY = 2;	-- микросхема памяти заменена
	ST_FLASH = 3;	-- флешка вставлена
	var {
		state = 0	-- текущее состояние
	};
	inv = function(s)
		p 'Мой старый верный ноутбук.'
		if s.state == s.ST_START then
			p 'К сожалению, у него испортилась микросхема памяти, и я не успел её заменить.'
		elseif s.state == s.ST_PANEL then
			p 'Задняя панель открыта.'
		elseif s.state == s.ST_MEMORY then
			p 'Теперь он снова в рабочем состоянии.'
		elseif s.state == s.ST_FLASH then
			p 'Флешка вставлена.'
		end
	end;
	used = function(s, w)
		if s.state == s.ST_START then
			if w == screwdriver then
				if here() == doctor_suitcase then
					p 'Сначала закончу с чемоданом, а потом займусь починкой ноутбука.'
				else
					s.state = s.ST_PANEL
					p 'Я открутил винты и снял заднюю панель.'
				end
			elseif w == scalpel then
				p 'Я попробовал открутить винты скальпелем, но это не получилось.'
			elseif w == notebook_memory then
				p 'Сначала надо снять заднюю панель ноутбука, которая прикручена винтами.'
			elseif w == rebecca_flash then
				p 'А смысл? Ноутбук-то всё равно нерабочий.'
			end
		elseif s.state == s.ST_PANEL then
			if w == notebook_memory then
				s.state = s.ST_MEMORY
				remove('notebook_memory', me());
				p 'Я вставил микросхему в гнездо и закрыл заднюю панель.'
			elseif w == rebecca_flash then
				p 'А смысл? Ноутбук-то всё равно нерабочий.'
			end
		elseif s.state == s.ST_MEMORY then
			if w == rebecca_flash then
				s.state = s.ST_FLASH
				remove('rebecca_flash', me())
				p 'Я включил ноутбук и вставил флешку, найденную в каюте художницы.'
				goto('rebecca_diary')
			end
		end
	end
};

notebook_memory = obj {
	nam = 'микросхема';
	inv = 'Микросхема памяти, надеюсь, целая.';
};

key_19 = obj {
	nam = 'ключ 19';
	inv = 'Ключ с биркой 19. Может быть, от комнаты в гостинице, или от камеры хранения?';
};

nippers = obj {
	nam = 'кусачки';
	dsc = 'В дальнем углу лежат {кусачки}.';
	tak = 'Я подобрал кусачки.';
	inv = 'Обычные кусачки.';
};

rope = obj {
	nam = 'канат';
	dsc = 'Сверху лежит кусок толстого {каната}.';
	tak = 'Я скрутил кусок каната и повесил его на плечо.';
	inv = 'Кусок каната длиной метра 4.';
};

cigarette_case = obj {
	nam = 'портсигар';
	dsc = 'На земле у начала аллеи {что-то} блестит.';
	tak = 'Я подобрал предмет, это оказался портсигар Энжел!!!';
	inv = 'Изящный портсигар, с которым Энжел никогда не расставалась. Значит, она где-то здесь, на острове!';
};

lighter = obj {
	nam = 'зажигалка';
	dsc = 'Слева на земле лежит какой-то {предмет}.';
	tak = 'Я поднял предмет и вздрогнул: это зажигалка Энжел!';
	inv = 'Я подарил эту зажигалку Энжел на день рождения.';
};

boarding_hook = obj {
	nam = 'абордажный крюк';
	var {
		with_rope = false
	};
	dsc = 'За обшивку цепляется {абордажный крюк} с канатом.';
	act = 'Крюк надежно зацепился за обшивку, вытащить его не удаётся.';
	inv = function(s)
		if s.with_rope then
			p 'Абордажный крюк с привязанным канатом.'
		else
			p 'Абордажный крюк.'
		end
	end;
	use = function(s, on)
		-- have() проверяет, что объект в инвентаре, а не на сцене
		if on == rope and have('rope') and not s.with_rope then
			s.with_rope = true
			remove('rope', me())
			return 'Я привязал канат к абордажному крюку.'
		end
	end;
	used = function(s, w)
		if w == rope and not s.with_rope then
			s.with_rope = true
			remove('rope', me())
			return 'Я привязал канат к абордажному крюку.'
		end
	end;
};

body_oil = obj {
	nam = 'масло для тела';
	inv = 'Можно намазать кожу, чтобы она блестела.';
};

rebecca_flash = obj {
	nam = 'флешка';
	inv = 'Флешка из сейфа в каюте художницы. На ней может быть полезная информация.';
};

safety_lock = obj {
	nam = 'предохранитель';
	inv = 'Электрический предохранитель.';
};

charger = obj {
	nam = 'зарядник';
	var {
		plugged = false		-- подключено к розетке
	};
	dsc = function(s)
		pr ' c подключенным {зарядным устройством}'
		if not objs():srch('doctor_phone') then
			p '.'
		end
	end;
	act = 'Зарядник подключен к розетке и готов к работе.';
	inv = 'Устройство для зарядки мобильников.';
	use = function(s, on)
		if on == doc_outlet and not s.plugged then
			s.plugged = true
			mydrop('charger')
			p 'Зарядное устройство подключено к розетке.'
		end
	end;
};

doctor_phone = obj {
	nam = 'мобильник доктора';
	var {
		charged = false, 	-- мобильник полностью заряжен
		charging = false,	-- мобильник заряжается 
	};
	--[[
		Логика зарядки:
		- подключаем зарядку к розетке
		- подключаем мобильник к зарядке
		- мобильник будет заряжаться (charging), пока мы не выйдем (exit)
		  из комнаты доктора
		- когда вернёмся, мобильник будет заряжен (charged)
	]]
	dsc = 'в котором заряжается {мобильник}.';
	use = function(s, on)
		if on == doc_outlet then
			p 'Мобильник нельзя подключить напрямую к розетке, вот если бы было зарядное устройство...'
			return false
		end
		if on == charger then
			if not charger.plugged then
				p 'Лучше сначала подключить зарядное устройство к розетке.'
				return false
			else
			    if not s.charged then 
			    	s.charging = true
					mydrop('doctor_phone')
					p 'Мобильник поставлен на зарядку.'
				else
					p 'Нет смысла, мобильник и так заряжен.'
					return false
				end
			end
		end
	end;
	tak = function(s)
		if s.charged then
			p 'Мобильник полностью зарядился.'
		else
			p 'Мобильник ещё не зарядился, надо подождать.'
			return false
		end
	end;
	inv = function(s)
		local code_str = tostring(lock_code)
		if lock_code < 10 then
			code_str = '00'..code_str
		elseif lock_code < 100 then
			code_str = '0'..code_str
		end
		if s.charged then
			local st = [[
			На мобильнике несколько последних отправленных SMS:
			^-----^
			Милая, я скоро буду дома! У меня для тебя подарок.
			^-----^
			Сегодня пристали к какому-то острову. Кругом туман.
			^-----^
			Привели матроса. Он изранен. Видно, на острове много диких зверей.
			^-----^
			Нужно бежать, иначе я не выберусь отсюда.
			^-----^
			Код: ]]..code_str..[[
			^-----^
			Они захватывают корабль!!!
			]]
			return st
		else
			p [[
			Надеюсь, теперь я узнаю, что здесь произошло! 
			Нет, не узнаю -- мобильник разряжен.
			]]
		end
	end
};

chisel = obj {
	nam = 'стамеска';
	inv = 'Довольно-таки прочная стамеска.';
};

scalpel = obj {
	nam = 'скальпель';
	inv = 'Острый как бритва!';
};

screwdriver = obj {
	nam = 'отвёртка';
	inv = 'Крестовая отвёртка, полезная в хозяйстве вещь.';
};

ring = obj {
	nam = 'кольцо';
	inv = 'Обручальное кольцо с бриллиантом.';
};

axe = obj {
	nam = 'топор';
	var {
		broken_near_cellar = false
	};
	dsc = 'Рядом с ним лежит {топор}.';
	tak = 'Я поднял топор. Ну хоть какое-то оружие!';
	inv = 'Топор с хлипкой рукояткой. Но он ещё может пригодиться.';
};

belt = obj {
	nam = 'ремень';
	inv = 'Старый ремень от генератора.';
};

secateur = obj {
	nam = 'секатор';
	dsc = 'В самом низу лестницы лежит {секатор}.';
	tak = 'Возможно, кто-то пытался перекусить решётку...';
	inv = 'Ножницы для обрезки кустов.';
};

dry_roses = obj {
	nam = 'сухие розы';
	var {
		cut = false
	};
	dsc = 'В ней стоят {засохшие розы}.';
	act = 'Хоть и засохшие, розы всё равно колючие!';
	inv = 'Колючие и сухие.';
	used = function(s, w)
		if w == secateur and not s.cut then
			s.cut = true
			take('dry_roses')
			remove('secateur', me())
			return 'Я срезал секатором розы.'
		end
	end;
};

branches = obj {
	nam = 'сучья';
	inv = 'Сухие сучья.';
};

key_cross = obj {
	nam = 'странный ключ';
	inv = 'Ключ с язычком в виде правильного креста.';
};

handsaw = obj {
	nam = 'ножовка';
	dsc = 'В шкафчике лежит {ножовка}.';
	tak = 'Я взял ножовку.';
	inv = 'Добротная ножовка по металлу.';
};

revolver = obj {
	nam = 'револьвер';
	inv = 'Надеюсь, осечки не будет!';
};

function bag_name(s)
	if s.with_holes then
		return 'дырявый мешок'
	else
		return 'мешок'
	end
end

bag = obj {
	var {
		with_holes = true
	};
	nam = function(s)
		return bag_name(s)
	end;
	dsc = function(s)
		p ('В кузове лежит {'..bag_name(s)..'}.')
	end;
	tak = function(s)
		if s.with_holes then
			p 'Зачем мне мешок с такой дырой?'
			return false
		else
			p 'Я взял мешок.'
			objs():add('truck_body_zodiak')
		end
	end;
	inv = function(s)
		if s.with_holes then
			p 'Мешок с крупной дырой.'
		else
			p 'Большой крепкий мешок.'
		end
	end;
	used = function(s, w)
		if w == needle and s.with_holes then
			s.with_holes = false
			remove('needle', me())
			p 'Я тщательно заштопал дыру в мешке.'
		end
	end
};

needle = obj {
	nam = 'иголка с ниткой';
--	dsc = 'В бардачке лежит {катушка ниток с иголкой}';
--	tak = 'Я взял катушку; может быть понадобится что-нибудь заштопать.';
	inv = 'Большая иголка с толстой ниткой.'
};	

insect_net = obj {
	nam = 'сачок';
	inv = 'Сачок для бабочек на длинной ручке.'
};	

-- функция для собирания знаков зодиака, печатает msg
function take_zodiak(msg)
	if zodiak.cnt >= zodiak.NEED_CNT then
		p 'Ошибка: вы пытаетесь взять фишек больше, чем необходимо!'
		return false
	end
	if zodiak.cnt == 0 then
		-- поместить в инвентарь
		take('zodiak')
	end
	zodiak.cnt = zodiak.cnt + 1
	p(msg)
end

zodiak = obj {
	--[[ 
	расположение фишек с зодиаками:
	- под полицейской каской
	- под мешком в кузове грузовика
	- в вентиляционной шахте рядом с входом в кабинет
	- в книжном шкафу в кабинете
	]]
	var {
		NEED_CNT = 4,   -- сколько надо найти, чтобы вставить в тайник
		cnt = 0			-- количество найденных фишек
	};
	nam = function(s)
		return 'знак зодиака ('..tostring(s.cnt)..')'
	end;
	inv = function(s)
		if s.cnt == 1 then
			p 'Каменная фишка со знаком зодиака.'
		else
			p 'Каменные фишки со знаками зодиака.'
		end
	end
};

-- спецобъект, помещается в инвентарь не он, а zodiak
truck_body_zodiak = obj {
	nam = 'зодиак в кузове';
	var {
		taken = false
	};
	dsc = 'На полу, за ящиком лежит {фишка} со знаком зодиака.';
	tak = function(s)
		if not s.taken then
			s.taken = true
			take_zodiak('Я взял фишку со знаком зодиака.')
			objs():del('truck_body_zodiak')
		end
		return false
	end
};

-- спецобъект, помещается в инвентарь не он, а zodiak
vent_mine_zodiak = obj {
	nam = 'зодиак в шахте';
	var {
		taken = false
	};
	dsc = 'В шахте лежит {фишка}.';
	tak = function(s)
		if not s.taken then
			s.taken = true
			take_zodiak('Я взял фишку со знаком зодиака.')
			objs():del('vent_mine_zodiak')
		end
		return false
	end
};

-- спецобъект, помещается в инвентарь не он, а zodiak
bookcase_zodiak = obj {
	nam = 'зодиак в книжном шкафу';
	var {
		taken = false
	};
	dsc = 'Позади книг лежит {фишка со знаком зодиака}.';
	tak = function(s)
		if not s.taken then
			s.taken = true
			take_zodiak('Я взял фишку.')
			objs():del('bookcase_zodiak')
		end
		return false
	end
};

wrench = obj {
	nam = 'разводной ключ';
	dsc = '{разводной ключ}, ';
	tak = 'Я взял разводной ключ.';
	inv = 'Разводной ключ.';
};

firehose = obj {
	nam = 'шланг';
	inv = 'Длинный пожарный шланг.';
};

key_teddy = obj {
	nam = 'ключик';
	inv = 'Маленький ключик от какого-то детского тайника.';
};

key_church = obj {
	nam = 'ключ с крестиком';
	dsc = 'В тайнике под ступенькой спрятан {какой-то предмет}.';
	tak = 'Из тайника я вытащил ключ с крестиком на цепочке.';
	inv = 'Солидный ключ с крестиком на цепочке.';
};

handkerchief = obj {
	var {
		wet = false
	};
	nam = function(s)
		if s.wet then 
			p 'мокрый платок'
		else
			p 'носовой платок'
		end
	end;			
	inv = function(s)
		if s.wet then 
			p 'Мокрый носовой платок.'
		else
			p 'Простой носовой платок.'
		end
	end;
	used = function(s, w)
		if w == scalpel then
			p 'Порезать скальпелем платок на мелкие кусочки? Но зачем?'
		end
	end
};

sun = obj {
	nam = 'диск солнца';
	inv = 'Вырезанный из дерева и покрытый бронзовой краской предмет с лучами-протуберанцами.';
};

red_dart = obj {
	nam = 'красный дротик';
	dsc = 'В сундучке лежит {красный дротик}.';
	tak = 'Я взял дротик.';
	inv = 'Красный дротик для дартс.';
};

green_dart = obj {
	nam = 'зелёный дротик';
	dsc = 'В сундучке лежит {зелёный дротик}.';
	tak = 'Я взял дротик.';
	inv = 'Зелёный дротик для дартс.';
};

blue_dart = obj {
	nam = 'синий дротик';
	dsc = 'В сундучке лежит {синий дротик}.';
	tak = 'Я взял дротик.';
	inv = 'Синий дротик для дартс.';
};

dial = obj {
	nam = 'наборный диск';
	dsc = 'На стене, где раньше была мишень, висит {наборный диск} от телефона.';
	tak = 'Я взял диск. Это кто ж его спрятал туда?';
	inv = 'Наборный диск от телефона.';
};

book_1898 = obj {
	nam = 'книга (1898)';
	dsc = 'На подоконнике витража лежит {книга}.';
	tak = 'Я взял книгу. Где-то я уже видел подобный корешок.';
	inv = 'Книга с надписью на корешке "1898".';
};

book_1904 = obj {
	nam = 'книга (1904)';
	dsc = 'Внутри глобуса оказалась спрятана {книга}.';
	tak = 'Я взял книгу. Где-то я уже видел подобный корешок.';
	inv = 'Книга с надписью на корешке "1904".';
};

paper = obj {
	nam = 'листок бумаги';
	dsc = ', {листок бумаги}';
	tak = 'Я взял листок.';
	inv = 'Обыкновенный желтоватый листок бумаги.';
};

pendant_1 = obj {
	nam = 'половинка кулона';
	dsc = 'На окне лежит {половинка кулона}.';
	tak = 'Я взял кулон. Раньше он принадлежал женщине.';
	inv = 'Половинка кулона в виде сердечка.';
};

pendant_2 = obj {
	nam = 'половинка кулона';
--	dsc = 'В бардачке кабины грузовика лежит {половинка кулона}.';
--	tak = 'Я взял половинку кулона.';
	inv = 'Половинка кулона в виде сердечка.';
};

cliche = obj {
	nam = 'трафарет';
	dsc = 'На секретере лежит картонный {трафарет}.';
	tak = 'Я взял трафарет. Наверное, это что-то важное.';
	inv = 'Трафарет, в котором вырезано 4 квадратика в виде буквы Y.';
};

coal = obj {
	nam = 'уголёк';
	dsc = 'Среди золы лежит крупный {уголёк}.';
	tak = 'Я взял уголёк. Он ещё тёплый.';
	inv = 'Кусочек угля из камина.';
};

hammer = obj {
	nam = 'молоток';
	dsc = 'В углублении люка лежит {молоток}.';
	tak = 'Я взял молоток. Не зря же его прятали!';
	inv = 'Молоток обыкновенный: ручка деревянная, шляпка железная.';
};

money = obj {
	nam = 'монеты';
	dsc = 'Среди осколков лежат {несколько монет}.';
	tak = 'Я положил монеты в карман.';
	inv = 'Несколько монет мелочью.';
};

