-- ПРОБУЖДЕНИЕ
coast_awake = room {
	nam = 'Пробуждение';
	pic = 'gfx/intro/1.jpg';
	dsc = [[
		...сознание прояснилось, и я очнулся. 
		Слышу шум воды, разбивающейся о камень. 
		Как приятно и спокойно: я лежу и слушаю шум воды. 
		Кажется, я мог бы лежать здесь вечно... 
		Чувства возвращаются ко мне; моя одежда мокрая, это неприятно.
		^^
		Внезапно острая мысль пронзила мозг: "{next|Что произошло???}"
	]];
	obj = {
		xact('next', code[[goto(coast_awake2);]]),
	};
};

coast_awake2 = room {
	nam = 'Пробуждение';
	pic = 'gfx/intro/2.jpg';
	dsc = [[
		Помню, мы были с Энжел на катере в открытом море. 
		День выдался удачный: мне удалось поднять с затонувшего 
		корабля несколько статуэток. Думаю, их можно было выгодно продать.
		^^
		Мы уже собирались плыть к берегу, {next|когда Энжел}...
	]];
	obj = {
		xact('next', code[[goto(coast_awake3);]]),
	};
};

coast_awake3 = room {
	nam = 'Пробуждение';
	pic = 'gfx/intro/3.jpg';
	dsc = [[
		...когда Энжел попросила показать ей одну из статуэток.
		Я наклонился, взял её в руки... Вспышка -- и я оказался в воде!
		Поcледнее, что я помню, это испуганное лицо Энжел...
		^^
		"Где же Энжел?" -- превозмогая боль, я {next|поднялся на ноги}.
	]];
	obj = {
		xact('next', code[[goto(coast);]]),
	};
};

-- БЕРЕГ
coast = room {
	nam = 'Берег';
	pic = 'gfx/coast/0.jpg';
	dsc = [[
		Я нахожусь на небольшом пятачке незнакомого берега. 
		Похоже, это остров.	Впереди скала, забраться на которую 
		без специального снаряжения невозможно. В скале темнеет ниша.
	]];
	obj = { 
		'co_wire_grid', 
		'co_motorboat', 
		'co_old_raft', 
		vway('co_suitcase_locked', 'На песке лежит {чемодан}.', 'doctor_suitcase_locked'),
	};
	way = { 'rock' };
};

co_wire_grid = obj {
	nam = 'проволочная сетка';
	var { 
		cut = false,	-- проволока разрезана? 
	};
	dsc = function(s)
		if not s.cut then
			return 'Слева путь вглубь острова преграждает забор из {проволочной сетки}.'
		end
	end;
	act = function(s)
		if s.cut then
			return 'Проволочная сетка разрезана.'
		end
		return 'Я не могу перелезть через этот забор. Но, может, Энжел выбросило дальше по берегу? Надо обязательно туда пройти.'
	end,
	used = function(s, w)
		if w == nippers and not s.cut then
		    s.cut = true
			remove('nippers', me())
			ways():add('passageway')
			return 'Немного помучившись, я разрезал проволоку. Путь свободен!'
		end
	end,
};

co_motorboat = obj {
	nam = 'катер';
	dsc = 'Справа наш {катер}, он разбит и наполовину выброшен на берег.';
	act = function()
		if not taken('flashlight') then
			take('flashlight')
			take('notebook')
			return 'Внимательно осмотрев катер, я нашел две чудом сохранившиеся вещи: фонарик и ноутбук.'
		end
		return 'Наш бывший катер. Больше на нём не осталось ничего полезного.'
	end;
};

co_old_raft = obj {
	nam = 'старый плот';
	var {
		msg_one = true
	};
	dsc = 'Рядом со мной {старый плот}.';
	act = function(s)
		p_12(s, 'Старый развалившийся плот, наверное, дети построили его.',
			'Не стоит и пытаться куда-либо плыть на этой развалюхе.')
	end;
};

-- СКАЛА
rock = room {
	nam = 'Скала';
	var {
		lighted = false
	};
	pic = function(s)
		if s.lighted then
			local pict = 'gfx/rock/niche_light.jpg'
			if taken('rope') then
				pict = pict..';gfx/rock/no_rope.jpg@116,140'
			end
			return pict
		else
			return 'gfx/rock/niche_dark.jpg'
	 	end	
	end;
	dsc = 'Я подошел к скале. Холодный серый камень, за который цепляется плющ.';
	obj = { 
		'rk_niche_dark'
	};
	way = {	'coast' };
};

rk_niche_dark = obj {
	nam = 'ниша';
	dsc = 'В скале видно большое {тёмное отверстие}.';
	act = 'Слишком темно, чтобы разглядеть что-нибудь.';
	used = function(s, w)
		if w == flashlight and not rock.lighted then
		    rock.lighted = true
		    replace('rk_niche_dark', 'rk_niche_light', rock)
			remove('flashlight', me())
			return 'Я включил фонарик и положил его на камень. Да будет свет!'
		end
	end;
};

rk_niche_light = obj {
	nam = 'ниша';
	dsc = 'В скале большая глубокая ниша.';
	obj = {
		'rk_jeans', 
		'rope',
		'nippers'
	};
};

rk_jeans = obj {
	nam = 'джинсы';
	dsc = 'Слева лежат старые потёртые {мужские джинсы} и сломанные очки.';
	act = function()
		if not taken('key_19') then
			take('key_19')
			return 'Порывшись в карманах, я нашёл ключ с биркой 19.'
		end
		return 'Больше в карманах ничего нет.'
	end,
};

-- ПРОХОД
passageway = room {
	nam = 'Проход';
	pic = function(s)
		local st = 'gfx/passageway/0.jpg'
		if not taken('cigarette_case') then
			st = st..';gfx/passageway/cigarette_case.jpg@273,239'
		end
		return st
	end;
	enter = function(s)
		if seen_animation and not ways():srch('avenue') then
			ways():add('avenue')
			objs():del('ps_avenue')
			return 'Они потащили Энжел в аллею.	За ней!'
		end
	end;
	dsc = function(s)
		p [[
			Никаких следов.	Плотные клубы тумана медленно плывут 
			от центра острова к берегу. 
			Впереди в дымке виден силуэт большого корабля.
		]];
	end;
	obj = { 
		'ps_avenue',
		'cigarette_case',
		vway('wanted', 'Справа на фонарном столбе висит неприметная {бумажка}.', 'passageway_wanted'),
	};
	way = { 'coast', 'near_ship' };
};

ps_avenue = obj {
	nam = 'аллея';
	dsc = 'Направо уходит {аллея}, мощёная плиткой.';
	act = 'Идти туда мне пока не хочется, надо сначала обследовать берег.';
};

passageway_wanted = room {
	nam = 'Разыскивается';
	pic = 'gfx/passageway/wanted.jpg';
	dsc = [[
		Объявление о пропаже почти 100-летней давности?^
		{back|Назад}
	]];
	obj = { 
		xact('back', code[[goto('passageway');]])
	};	
};

-- РЯДОМ С КОРАБЛЕМ
near_ship = room {
	nam = 'Рядом с кораблем';
	pic = function()
		if ns_fragmentary_hole.is_hooked then
			p 'gfx/near_ship/hook.jpg'
		else
			p 'gfx/near_ship/0.jpg'
		end
	end;
	dsc = [[
		Берег моря, всё затянуто белесым туманом. 
		Прямо передо мной корма большого корабля, гребные винты 
		торчат из воды. Судя по всему, судно стоит здесь уже давно: 
		куски обшивки облупились, и корпус начал ржаветь.
	]];
	obj = {
		'ns_fragmentary_hole',
		'ns_fire'
	};
	way = { 'passageway' };
};

ns_fragmentary_hole = obj {
	nam = 'рваная дыра';
	var { 
		is_hooked = false	-- закинули крюк в дыру?
	};
	dsc = function(s)
		p [[На высоте нескольких метров от земли в обшивке корабля имеется 
			{рваная дыра}, листы металла выгнуты наружу.]]
	end;
	act = 'Такое ощущение, будто огромная сила прорвала корпус корабля изнутри. Что это было?';
	used = function(s, w)
		if not s.is_hooked then
			if w == boarding_hook then
				if boarding_hook.with_rope then
					s.is_hooked = true
					ways():add('rebecca_cabin_ghost')
					-- вставим крюк до костра в список объектов
					objs():del('ns_fire')
					mydrop('boarding_hook')
					objs():add('ns_fire')
					return 'После нескольких попыток мне удалось зацепиться крюком за край дыры. Теперь можно забраться по канату и заглянуть внутрь корабля.'
				else
					p 'Ну закину я крюк, а что дальше?'
					return false
				end
			elseif w == rope then
				p 'Какой смысл закидывать канат? Он не сможет зацепиться.'
				return false
			end
		end
	end;
};

ns_fire = obj {
	nam = 'костёр';
	dsc = 'На берегу ярко горит {костёр}.';
	act = function()
		if not taken(boarding_hook) then
			take('boarding_hook')
			return 'Рядом с костром я нашёл абордажный крюк. Весьма кстати!'
		end
		p 'Раз есть костёр, значит, рядом должны быть люди?'
	end;
};

-- КОМНАТА РЕБЕККИ (одноразовая)
rebecca_cabin_ghost = room {
	nam = 'Каюта с дырой';
	pic = 'gfx/ship/rebecca_cabin/ghost.jpg';
	hideinv = true;
	dsc = [[
		Когда я заглянул в каюту, я увидел призрака, полупрозначную тень... 
		Это женщина, она что-то делает у камина.
		^^ 
		{next|Наверное, показалось...}
	]];
	obj = { 
		xact('next', 
			code[[
			ways(near_ship):replace(rebecca_cabin_ghost, rebecca_cabin);
			goto(rebecca_cabin);
			]]),
	};
};

-- КОМНАТА РЕБЕККИ
rebecca_cabin = room {
	nam = 'Каюта художницы';
	pic = function(s)
		local st = 'gfx/ship/rebecca_cabin/0.jpg'
		if rb_picture.cut then
			if safe_puzzle.solved then
				if taken('rebecca_flash') then 
					st = st..';gfx/ship/rebecca_cabin/safe_open.jpg@44,66'
				else
					st = st..';gfx/ship/rebecca_cabin/safe_open_oil.jpg@44,66'
				end
			else
				st = st..';gfx/ship/rebecca_cabin/safe_closed.jpg@44,66'
			end
		end
		return st
	end;
	dsc = [[
		В комнате беспорядок. Перевёрнутые стулья, исцарапанная мебель... 
		Везде недописанные картины, на полу валяются мольберт, кисти...
		Над камином {mirror|разбитое зеркало}.
	]];
	obj = { 
		xact('mirror', 'Говорят: разбитое зеркало к несчастью...'),
		'rb_picture',
		'rb_notebook',
		'rb_fireplace'
	};
	way = { 'near_ship', 'corridor' };
};

rb_picture = obj {
	nam = 'картина';
	var {
		cut = false
	};
	dsc = function(s)
		if not s.cut then
			p 'Слева на стене висит {картина}.'
		else
			p 'Слева в стене расположен {сейф}.'
		end
	end;
	act = function(s)
		if not s.cut then
			p 'Какой-то морской пейзаж. Часто за такими картинами прячут тайники.'
		elseif not safe_puzzle.solved then
			goto(safe_puzzle)
		elseif not taken('rebecca_flash') then
			take('rebecca_flash')
			take('body_oil')
			p 'Я достал из сейфа розовую флешку и флакон с маслом для тела. Интересный набор!'
		else
			p 'Больше в сейфе ничего нет.'
		end
	end;
	used = function(s, w)
		if w == scalpel and not s.cut then
			s.cut = true
			p 'Я разрезал холст и обнаружил под ним сейф. Сейчас попробую открыть.'
		end
	end
};

rb_notebook = obj {
	nam = 'ноутбук';
	dsc = 'На незастеленной кровати какие-то тёмные отпечатки. Там же лежит {ноутбук}, его дисплей разбит.';
	act = function(s)
		if not taken('notebook_memory') then
			take('notebook_memory')
			return 'Я осмотрел ноутбук. Задняя панель оказалась сломанной, и я вынул микросхему памяти. Вдруг пригодится.'
		end
		p 'Почему женщины так любят эти розовые ноутбуки?'
	end;
	used = function(s, w)
		if w == rebecca_flash then
			p 'Ноутбук безнадёжно испорчен, ничего не получится.'
		end
	end
};

rb_fireplace = obj {
	nam = 'камин';
	dsc = 'Справа {камин} с ажурной решёткой.';
	act = 'Внутри камина большая куча остывшего пепла, обрывки обгоревшего холста. Боже, зачем кому-то понадобилось сжигать картины???';
};

-- КОРИДОР
corridor = room {
	nam = 'Коридор';
	var {
		wires_off = false,
		cabin19_open = false
	};
	pic = function(s)
		local pict = 'gfx/ship/corridor/0.jpg'
		if s.wires_off then
			pict = pict..';gfx/ship/corridor/wires_off.jpg@0,0'
		end
		if s.cabin19_open then
			pict = pict..';gfx/ship/corridor/cabin19_open.jpg@185,57'
		end
		if cor_carpet.cut then
			pict = pict..';gfx/ship/corridor/carpet_cut.jpg@78,197'
		end
		return pict
	end;
	dsc = function(s)
		if not s.wires_off then
			p [[
				С потолка свисают оголённые провода. 
				Ого, да тут всё под напряжением!!!
			]]
		end
		p [[
			Проход вглубь корабля заблокирован предметами мебели
			и прочим {garbage|хламом}.
		]]
	end;
	obj = { 
		xact('garbage', 'Гм, похоже кто-то пытался построить баррикаду!'),
		'cor_door_19',
		'cor_carpet',
		'cor_dark_paws',
		'cor_switchboard',
		vway('cor_newspaper', 'На полу лежит {газета}.', 'corridor_newspaper'),
	};
	exit = function(s, to)
		if to == restaurant and not s.wires_off then
			p 'Если я не хочу поджариться, то не стоит туда идти!'
			return false
		end
	end;
	way = { 'rebecca_cabin', 'restaurant', 'downstairs' };
};

cor_door_19 = obj {
	nam = 'дверь каюты 19';
	dsc = 'В коридор выходит несколько кают, {одна из кают} закрыта.';
	act = 'Каюта с номером 19. Я подёргал ручку, но дверь закрыта на ключ.';
	used = function(s, w)
		if w == key_19 and not corridor.cabin19_open then
			corridor.cabin19_open = true
			ways():add('doctor_cabin_ghost')
			remove('key_19', me())
			objs():del('cor_door_19')
			return 'Дверь каюты открылась!'
		end
	end;
};

-- c ковром пока взаимодействовать нельзя!
cor_carpet = obj {
	nam = 'ковёр';
	dsc = 'Под ногами красный ковёр,'
};

--[[
cor_carpet = obj {
	nam = 'ковёр';
	var {
		cut = false
	};
	dsc = function(s)
		if s.cut then
			p 'Под ногами красный ковёр,'
		else
			p 'Под ногами {красный ковёр},'
		end
	end;
	act = 'На полу под сукном прощупывается какой-то круглый предмет, но я не могу отвернуть ковёр, так как он придавлен этажеркой.';
	used = function(s, w)
		if (w == scalpel or w == secateur) and not s.cut then
			s.cut = true
			objs():add('cor_hatch')
			return 'Я разрезал ковер, под ним оказался люк.'
		end
	end;
};
]]

cor_dark_paws = obj {
	nam = 'тёмные лапы';
	var {
		msg_one = true
	};
	dsc = 'на нём отчётливо видны отпечатки {тёмных лап}.';
	act = function(s)
		p_12(s, 'Чьи они? Для собаки слишком крупные... Да и нет у собаки таких длинных пальцев.',
				'Если честно, я не хотел бы встретить с этим животным лицом к лицу.')
	end;
};

cor_switchboard = obj {
	nam = 'распределительный щит';
	dsc = 'На стене висит {распределительный щит}, дверка болтается на честном слове.';
	act = function()
		if not taken(safety_lock) then
			take('safety_lock')
			corridor.wires_off = true
			return 'Осторожно, одной рукой я вынул из щитка один предохранитель. Провода в коридоре перестали искрить.'
		end
		return 'Лучше не трогать другие предохранители, чтобы не обесточить весь корабль.'
	end;
	used = function(s, w)
		if w == safety_lock then
			p 'Нет смысла рисковать, оголённые провода могут вызвать короткое замыкание.'
			return false
		end
	end,
};

cor_hatch = obj {
	nam = 'люк';
	dsc = 'На полу {люк}.';
	act = 'Люк закрыт.';
};

corridor_newspaper = room {
	nam = 'Газета';
	pic = 'gfx/ship/corridor/newspaper.jpg';
	dsc = [[
		{back|Закрыть}
	]];
	obj = { 
		xact('back', code[[goback();]])
	};	
};

--[[
cor_newspaper = obj {
	nam = 'газета';
		30 июля 2008 -- Местные Бермуды
		^^
		В очередной раз пропало рыболовецкое судно. Поиски пока не дали
		результатов. В последний раз от небольшого рыбацкого катера
		пришел сигнал, когда тот находился в так называемых "Гиблых водах".
		Скептики утверждают, что вряд ли какие-либо следы найдутся,
		так как за последние 100 лет здесь пропало без вести около 60 судов.
		Причем в последние годы такие случаи участились. В связи с этим
		возникает вопрос -- как долго правительство будет игнорировать 
		подобные проиcшествия?
};
]]

-- КОМНАТА ДОКТОРА (одноразовая)
doctor_cabin_ghost = room {
	nam = 'Каюта 19';
	pic = 'gfx/ship/doctor_cabin/ghost.jpg';
	hideinv = true;
	dsc = [[
		Вот, опять! Я вижу призрак мужчины, который склонился
		над кроватью. Он что-то прячет под подушкой...
		^^ 
		{next|Совсем нервы расшатались...}
	]];
	obj = { 
		xact('next', 
			code[[
			ways(corridor):replace(doctor_cabin_ghost, doctor_cabin);
			goto(doctor_cabin);
			]]),
	};
};

-- КОМНАТА ДОКТОРА
doctor_cabin = room {
	nam = 'Каюта доктора';
	pic = 'gfx/ship/doctor_cabin/0.jpg';
	dsc = [[
		Лунный свет освещает каюту.
		На стене висит ящик с красным крестом, этажерка с книгами и фотографии.
		В стене каюты дыра, из неё тянет сквозняком.
	]];
	obj = {
		'doc_clock',
		'doc_illum',
		'doc_pillow',
		'doc_newspaper',
		vway('тумбочка', 'У кровати стоит {тумбочка}.', 'doctor_tumba'),
		'doc_outlet',
	};
	exit = function(s)
		-- при выходе из комнаты стоящий на зарядке мобильник 
		-- будет считаться заряженым
		if doctor_phone.charging then
			doctor_phone.charged = true
		end
	end;
	way = { 'corridor' };
};

doc_clock = obj {
	nam = 'часы';
	dsc = 'Большие {часы} в виде штурвала';
	act = 'Секундная стрелка безуспешно пытается сдвинуться с места.';
};

doc_illum = obj {
	nam = 'иллюминаторы';
	var {
		first = true
	};
	dsc = 'и {иллюминаторы} являются заметной частью интерьера.';
	act = function(s)
		if s.first then
			s.first = false
			return 'Я выглянул и увидел промелькнувшую тень...'
		else
			return 'Я вижу кусочек берега, волны и туман...'
		end
	end;
};

doc_pillow = obj {
	nam = 'подушка';
	dsc = 'На аккуратно застеленной кровати лежит {подушка}, раскрытая книга, стетоскоп';
	act = function(s)
		if not taken('doctor_phone') then
			take('doctor_phone')
			return 'Посмотрим, что там прятал доктор... О, мобильник!'
		end
		p 'Под подушкой доктор прятал свой мобильник.'
	end;
	used = function(s, w)
		if w == scalpel then
			p 'Я, конечно, могу распотрошить подушку. Но зачем?'
			return false
		end
	end;
};

doc_newspaper = obj {
	nam = 'газета';
	dsc = 'и {газета}.';
	act = [[
		20 августа 2008 -- Тайны острова
		^^
		В этот день, ровно 10 лет назад, от строителей, работающих 
		на одном из островов у берегов Испании, поступил сигнал бедствия.
		Спасательная экспедиция, прибывшая на место, следов	рабочих
		не обнаружила. Бригада должна была начать строительство
		рыболовного промышленного комплекса...
	]];
};

doc_outlet = obj {
	nam = 'розетка';
	dsc = function(s)
		pr 'Рядом с тумбочкой {розетка}'
		if not charger.plugged then	
			p '.' 
		end
	end;
	act = 'Электрическая розетка.';
};

-- ТУМБОЧКА ДОКТОРА
doctor_tumba = room {
	nam = 'Тумбочка';	-- bedside table
	pic = function(s)
		if t_upper.closed then
			return 'gfx/ship/doctor_cabin/tumba_closed.jpg'
		else
			return 'gfx/ship/doctor_cabin/tumba_open.jpg'
		end
	end;
	dsc = [[
		Прикроватная тумбочка с тремя ящиками. На тумбочке склянки, пузырьки 
		и {drugs|таблетки}.
	]];
	obj = {
		xact('drugs', 'Выпить неизвестные таблетки и откинуть копыта? Нет уж!'),
		't_upper',
		't_middle',
		't_lower',
	};
	way = { 'doctor_cabin' };
};

t_upper = obj {
	nam = 'верхний ящик';
	var {
		closed = true
	};
	dsc = '{Верхний ящик}.^';
	act = function(s)
		if s.closed then
			return 'Верхний ящик закрыт на ключ.'
		elseif not taken('charger') then
			take('charger')
			take('scalpel')
			return 'Вот удача: в ящике я нашёл зарядник и скальпель.'
		else
			return 'В ящике больше ничего полезного нет.'
		end
	end;
	used = function(s, w)
		if w == chisel and s.closed then
			s.closed = false
			remove(chisel, me())
			return 'Просунув лезвие стамески в щель, мне удалось отогнуть язычок замка и открыть ящик.'
		end
	end;
};

t_middle = obj {
	nam = 'средний ящик';
	dsc = '{Средний ящик}.^';
	act = 'Я выдвинул средний ящик, но он оказался пуст.';
};

t_lower = obj {
	nam = 'нижний ящик';
	dsc = '{Нижний ящик}.';
	act = function(s)
		if not taken('chisel') then
			take('chisel')
			return 'Покопавшись в ящике, я нашёл стамеску.'
		end
		p 'В ящике разный хлам.'
	end;
};

-- РЕСТОРАН
restaurant = room {
	nam = 'Ресторан';
	pic = 'gfx/ship/restaurant/0.jpg';
	dsc = [[
		Мебель разбросана, но с виду неплохой ресторан. 
		Не знаю, как тут готовили, а на дизайнеров явно не поскупились. 
		{eat|Поесть бы сейчас}...
	]];
	obj = { 
		xact('eat', [[
			При мысли о еде мой желудок свело... 
			Я не ел с самого утра... а может и дня... 
			я не помню, какой сегодня день...
			Но у меня нет на это времени!
			Я должен найти Энжел!
		]]),
		're_jukebox',
	};
	way = { 'corridor' };
};

re_jukebox = obj {
	nam = 'музыкальный автомат';
	dsc = 'У колонны стоит {музыкальный автомат}.';
	act = 'Добавим немного музыки в это печальное место!';
};

-- ВНИЗ на 1-ую палубу
downstairs = room {
	nam = 'Вниз';
	pic = 'gfx/ship/downstairs/0.jpg';
	obj = {
		'dn_lattice',
		'dn_things',
		'secateur'
	};
	way = { 'corridor' };
};

dn_lattice = obj {
	nam = 'железная решётка';
	dsc = 'Перила сломаны. Лестница, ведущая на нижнюю палубу, упирается в {решётку}.';
	act = 'Закрыто на замок, дальше не пройти.';
};

dn_things = obj {
	nam = 'вещи пассажиров';
	dsc = 'На полу разбросаны {вещи} пассажиров: часы, шляпа, туфля, потёртый кошелёк.';
	act = 'Брать личные вещи нехорошо; я же не мародёр!';
};

-- ЧЕМОДАН ДОКТОРА (ЗАМОК)
doctor_suitcase_locked = room {
	var {
		first_enter = true,
		first_dsc = true,
		digit1 = 0,
		digit2 = 0,
		digit3 = 0,
	};
	enter = function(s)
		if s.first_enter then
			s.digit1 = rnd(10) - 1
			s.digit2 = rnd(10) - 1
			s.digit3 = rnd(10) - 1
			s.first_enter = false
		end
	end;
	nam = 'Замок чемодана';
	pic = function(s)
		return 'gfx/coast/suitcase_lock/0.jpg;'..
			'gfx/coast/suitcase_lock/code_'..tostring(s.digit1)..'.jpg@188,142;'..
			'gfx/coast/suitcase_lock/code_'..tostring(s.digit2)..'.jpg@237,142;'..
			'gfx/coast/suitcase_lock/code_'..tostring(s.digit3)..'.jpg@285,142;'
	end;
	dsc = function(s)
		if s.first_dsc then
			p 'Это не наш чемодан. Интересно, чей он?'
			s.first_dsc = false
		elseif have('doctor_phone') and doctor_phone.charged and rnd(2) == 1 then
			p 'Мне кажется, где-то я уже видел код...'
		else
			p '3 кнопки, 1000 комбинаций. Надеюсь, мне повезёт!'
		end
	end;
	obj = { 
		vobj('one',   '{<левая>} . . .'),
		vobj('two',   '{<средняя>} . . .'),
		vobj('three', '{<правая>}'),
		vway('exit',  '^^{Выход}', 'coast'),
	};
	act = function(s, w)
		if w == 'one' then
			s.digit1 = s.digit1 + 1
			if s.digit1 > 9 then 
				s.digit1 = 0
			end
		elseif w == 'two' then
			s.digit2 = s.digit2 + 1
			if s.digit2 > 9 then 
				s.digit2 = 0
			end
		elseif w == 'three' then
			s.digit3 = s.digit3 + 1
			if s.digit3 > 9 then 
				s.digit3 = 0
			end
		end
		local val = 100*s.digit1 + 10*s.digit2 + s.digit3
		if val == lock_code then
			if have('doctor_phone') and doctor_phone.charged then
				p 'БИНГО!!!'
				remove('doctor_phone', me())
				objs(coast):del('co_suitcase_locked')
				objs(coast):add(vway('co_suitcase', 'На песке лежит {чемодан}.', 'doctor_suitcase'))
				goto('doctor_suitcase')
				return true
			else
				return 'Наверное, замок заклинило!'
			end
 		end
 		-- неверный код
 		local r = rnd(10)
 		if r == 3 then
 			p 'У меня уже стёрся палец крутить колёсики.'
 		elseif r == 7 then
 			p 'Не получается.'
 		elseif r == 9 then
 			p 'Чёртов замок!'
 		else
 			p 'Попробую так...'
		end
		return true
	end
};

-- ЧЕМОДАН ДОКТОРА
doctor_suitcase = room {
	nam = 'Чемодан';
	pic = function(s)
		local st = 'gfx/coast/suitcase/0.jpg'
		if su_box.opened then
			st = st..';gfx/coast/suitcase/box_open.jpg@59,52'
		end
		if su_case.opened then
			st = st..';gfx/coast/suitcase/case_open.png@111,155'
		end
		if taken('ring') then
			st = st..';gfx/coast/suitcase/ring_taken.jpg@156,77'
		end
		if taken('screwdriver') then
			st = st..';gfx/coast/suitcase/screwdriver_taken.jpg@141,192'
		end
		return st
	end;
	dsc = [[
		Передо мной чемодан доктора, все вещи аккуратно разложены.
		Посмотрим, что же в нём...
	]];
	obj = { 
		'su_photo1',
		'su_scarfs',
		'su_case',
		'su_flask',
		'su_photo2',
		'su_box',
		vway('su_diary', '{Дневник} доктора.', 'doctor_diary')
	};
	way = { 'coast' };
};
		
su_photo1 = obj {
	nam = 'фото1';
	dsc = '{Фотография} молодой особы.';
	act = 'Красивая леди...';
};

su_scarfs = obj {
	nam = 'платки';
	dsc = 'Стопка носовых {платков}.';
	act = function(s)
		if not taken('handkerchief') then
			take('handkerchief')
			p 'Так и быть, возьму один платок.'
		else
			p 'Я думаю, одного платка мне хватит.'
		end
	end
};

su_photo2 = obj {
	nam = 'фото2';
	dsc = 'Ещё {фотография}: доктор с той же женщиной под ручку.';
	act = 'Нетрудно догадаться, что это возлюбленная доктора.';
};

su_flask = obj {
	nam = 'фляга';
	dsc = '{Фляга} со спиртным.';
	act = 'Я открутил пробку и понюхал: коньяк или виски... Но не время сейчас пить!';
};

su_box = obj {
	nam = 'коробочка';
	var {
		opened = false,
	};
	dsc = function(s)
		if not s.opened then
			p '{Коробочка}, перевязанная красной лентой.'
		elseif not taken('ring') then
			p 'Коробочка, в ней {кольцо} с бриллиантом.'
		else
			p 'Коробочка, в которой было кольцо.'
		end
	end;
	act = function(s)
		if not s.opened then
			s.opened = true
			p 'Как я так и предполагал!'
		elseif not taken('ring') then
			take('ring')
			p 'Доктору это кольцо теперь вряд ли понадобится, а мне может пригодиться!'
		end
	end
};

su_case = obj {
	nam = 'футляр';
	var {
		opened = false,
	};
	dsc = function(s)
		if not s.opened then
			p '{Футляр} для очков.'
		elseif not taken('screwdriver') then
			p 'Открытый футляр, в нём очки и {отвёртка}.'
		else
			p 'Открытый футляр, в нём очки.'
		end
	end;
	act = function(s)
		if not s.opened then
			s.opened = true
			p 'Я открыл футляр.'
		elseif not taken('screwdriver') then
			take('screwdriver')
			p 'Я взял из футляра отвёртку.'
		end
	end
};

-- ДНЕВНИК ДОКТОРА
doctor_diary = room {
	var {
		page = 1
	};
	nam = 'Дневник доктора';
	pic = function(s)
		return 'gfx/doctor_diary/'..tostring(s.page)..'.jpg'
	end;
	dsc = 'С волнением открыл я дневник доктора...';
	obj = { 
		vobj('prev', '{< назад} . . .'),
		vobj('next', '{вперёд >}'),
		vway('exit', '^^{Закрыть}', 'doctor_suitcase'),
	};
	act = function(s, w)
		if w == 'prev' then
			if s.page > 1 then 
				s.page = s.page - 1
			end
		elseif w == 'next' then
			if s.page < 10 then 
				s.page = s.page + 1 
			end
		end
		return 'страница: '..tostring(s.page)
	end;
};

-- ДНЕВНИК РЕБЕККИ
-- переходим сюда автоматом, когда вставили в ноутбук флешку
-- выход: переход на просмотр анимации
rebecca_diary = room {
	var {
		page = 1
	};
	nam = 'Дневник художницы';
	pic = function(s)
		return 'gfx/rebecca_diary/'..tostring(s.page)..'.jpg'
	end;
	obj = { 
		vobj('prev', '{< назад} . . .'),
		vobj('next', '{вперёд >}'),
		vway('exit', '^^{Закрыть}', 'drag_body')
	};
	act = function(s, w)
		if w == 'prev' then
			if s.page > 1 then 
				s.page = s.page - 1
			end
		elseif w == 'next' then
			if s.page < 9 then 
				s.page = s.page + 1 
			end
		end
		return 'запись: '..tostring(s.page)
	end
};

-- АНИМАЦИЯ КАК ТАЩАТ ТЕЛО
-- вызывается после того, как в ноутбук вставлена флешка
timer.callback = function(s)
	drag_body.frame = drag_body.frame + 1
	if drag_body.frame == 2 then
		timer:set(800)
	elseif drag_body.frame == 3 then
		timer:set(600)
	elseif drag_body.frame == drag_body.LAST_FRAME then
		timer:stop()
	end
	-- заставляет перерисовать сцену
	return 'look'
end

drag_body = room {
	nam = '???';
	hideinv = true;
	LAST_FRAME = 7;
	var {
		first = true,
		frame = 1
	};
	enter = function(s)
		if s.first then
			seen_animation = true
			remove('notebook', me())
			timer:set(1000)
			s.first = false
		end
	end;
	pic = function(s)
		return 'gfx/drag_body/'..tostring(s.frame)..'.jpg'
	end;
	dsc = function(s)
		if s.frame == s.LAST_FRAME then
		    p [[
		    	Что это было?
		    	^^
				Я слышал женский крик -- и это была Энжел, её голос 
				я ни с чьим не перепутаю! Те, кто причинил ей вред,
				успели скрыться, но я их непременно догоню.
				Держись, любимая!
				^^
				{next|Дальше}
			]]
		end
	end;
	obj = {
		xact('next', code[[goto(passageway);]])
	};
};

