-- АЛЛЕЯ
avenue = room {
	nam = 'Аллея';
	pic = function(s)
		local st = 'gfx/avenue/0.jpg'
		if not taken('lighter') then
			st = st..';gfx/avenue/lighter.jpg@120,251'
		end
		return st
	end;
	dsc = [[
		Пустынная аллея ведёт вглубь острова. Кругом никого.
		Впереди виднеется что-то похожее на фонтан.
		Белесый туман заволакивает всё вокруг.
	]];
	obj = { 
		'lighter'
	};
	way = { 'passageway', 'fork' };
};

-- ФОНТАН (бывшая РАЗВИЛКА)
fork = room {
	nam = 'Фонтан';
	var {
		fire = true			-- пламя горит (преграждает путь) 
	};
	pic = function(s)
		local st = 'gfx/fork/0.jpg'
		if not taken('axe') then
			st = st..';gfx/fork/axe.jpg@104,217'
		end
		if fo_paper_booth.glass_broken then
			st = st..';gfx/fork/glass_broken.jpg@377,132'
		end
		if fo_paper_booth.got_newspaper then
			st = st..';gfx/fork/news.jpg@338,231'
		end
		if np_hydrant.with_hose then
			if np_hydrant.with_water then
				if s.fire then
					st = st..';gfx/fork/hose_water_flame.jpg@121,151'
				else
					st = st..';gfx/fork/hose_water_noflame.jpg@73,95'
				end
			else
				st = st..';gfx/fork/hose_nowater_flame.jpg@120,150'
			end
		end
		return st
	end;
	dsc = [[
		Передо мной небольшая развилка с фонтаном в центре. 
		Мощёная дорога уходит вправо. Слева вдали виднеется 
		остроконечное здание, дорога к которому идёт через парк. 
		{empty|Пустынно...}
	]];
	obj = { 
		xact('empty', 'Где же все люди?'),
		'fo_flame',
		'fo_machine',
		'fo_fountain',
		'axe',
		'fo_paper_booth',
	};
	way = { 'avenue', 'near_police' };
};

fo_flame = obj {
	nam = 'пламя';
	dsc = 'Сильное {пламя} мешает пройти в парк.';
	act = 'Я не могу подойти близко к огню, не понимаю почему. Хотя огонь и не очень большой, но он обжигает меня.';
};

fo_machine = obj {
	nam = 'машина';
	dsc = 'Слева у дерева стоит какая-то {машина}.';
	act = function(s)
		if not taken('belt') then
			take('belt')
			return 'То ли генератор, то ли ещё что. Машина явно не работает, а вот ремень мне может пригодиться.'
		else
			return 'То ли генератор, то ли ещё что.'
		end
	end
};

fo_fountain = obj {
	nam = 'фонтан';
	dsc = 'В центре площадки расположен {фонтан}.';
	act = 'Старинный фонтан с чашей, в нём ни капли воды. Неизвестно, когда он работал в последний раз.';
};

fo_paper_booth = obj {
	nam = 'газетный автомат';
	var {
		glass_broken = false,
		got_newspaper = false,
		msg_one = true
	};
	dsc = function(s)
		pr 'Справа стоит допотопный {газетный автомат}'
		if s.glass_broken then
			p ' с треснувшим стеклом.'
		else
			p '.'
		end
	end;
	act = function(s)
		p_12(s, 'Сколько же лет этому аппарату? Кажется, внутри местная газета.',
			'Чтобы достать газету, нужна монетка.')
	end;
	used = function(s, w)
		if w == axe or w == hammer then
			if not s.glass_broken then
				s.glass_broken = true
				local tool = 'топором'
				if w == hammer then tool = 'молотком' end
				return 'Размахнувшись, я ударил '..tool..' по лицевой панели -- стекло слегка треснуло, но не разбилось.'
			else
				return 'А, может, хватит уже вандализма?'
			end
		end
		if w == money and not s.got_newspaper then
			s.got_newspaper = true
			remove('money', me())
			objs():add(vway('fo_newspaper', 'На мостовой лежит {газета}.', 'fork_newspaper'))
			p 'Я бросил несколько монет в щель автомата, и, наконец, он выплюнул на мостовую газету.'
		end
	end;
};

fo_hose = obj {
	nam = 'подключенный шланг';
	dsc = function(s)
		if np_hydrant.with_hose then
			p 'На земле лежит пожарный {шланг}.'
			if np_hydrant.with_water then
				p 'Из него течёт вода.'
			end
		end
	end;
	act = function(s)
		if np_hydrant.with_water then
			if fork.fire then
				fork.fire = false
				disable('fo_flame')
				ways():add('fork2church')
				p 'Achtung, Feuer! Я взял шланг наперевес и с упоением водил им из стороны в сторону, пока не затушил всё пламя.'
			else
				p 'Я уже затушил пламя; и мой пыл пожарника утолён.'
			end
		elseif np_hydrant.with_hose then
			p 'В шланге нет воды.'
		end
	end
};

fork_newspaper = room {
	nam = 'Убийство!';
	pic = 'gfx/fork/newspaper.jpg';
	dsc = [[
		Эту фотографию я уже видел в доме, в тайнике.^
		{back|Закрыть}
	]];
	obj = { 
		xact('back', code[[goto(final);]])	-- goback()
	};	
};

-- РЯДОМ С ПОЛИЦИЕЙ
near_police = room {
	nam = 'Рядом с полицией';
	pic = function(s)
		local st = 'gfx/near_police/0.jpg'
		if not np_door.broken then
			st = st..';gfx/near_police/door.jpg@15,115'
		end
		if np_hydrant.with_hose then
			st = st..';gfx/near_police/hose.jpg@0,213'
		end
		return st
	end;
	dsc = [[
		Дорога упирается в фигурные ворота, за которыми виден особняк. 
		Слева расположено кирпичное здание с остроконечной 
		крышей -- местный дворец правосудия. 
		{empty|Кругом ни души...}
	]];
	obj = { 
		xact('empty', 'Только вороны повсюду сопровождают меня, или это мне кажется?!'),
		'np_truck',
		'np_door',
		'np_hydrant',
		vway('newspaper', 'Справа на скамейке лежит {газета}.', 'near_police_newspaper'),
	};
	way = { 'fork', 'truck_body', 'near_house' };
};

np_truck = obj {
	nam = 'грузовик';
	var {
		msg_one = true
	};
	dsc = '{Грузовик} проломил стену полицейского участка и застрял в ней.';
	act = function(s)
		p_12(s, 'Это ж надо было так напиться!!!',
			'Странно, что грузовик не вытащили, а стену не заделали...')
	end;
};

np_door = obj {
	nam = 'дверь';
	var {
		broken = false
	};
	dsc = function(s)
		if not s.broken then
			p 'Вход в полицейский участок закрывает {дверь}.'
		else
			p 'В двери полицейского участка {зияет дыра}.'
		end
	end;
	act = function(s)
		if not s.broken then
			p 'Деревянная дверь шатается, но не поддаётся.'
		else
			p 'Я был вынужден сделать это.'
		end
	end;
	used = function(s, w)
		if w == axe and not s.broken then
			s.broken = true
			ways():add('police_station')
			p 'Несколько сильных ударов и мне удалось прорубить дыру такого размера, чтобы можно было пролезть внутрь.'
			-- если ствол и ветки у подвала уже перерублены, бросаем топор
			if taken('branches') then
				remove('axe', me())
				p 'Но при этом хлипкое топорище сломалось -- вот досада!'
			end
		end
	end;
};

np_hydrant = obj {
	nam = 'гидрант';
	var {
		with_hose = false,  	-- присоединён шланг
		with_water = false		-- пущена вода
	};
	dsc = function(s)
		pr 'Слева на тротуаре торчит {гидрант}'
		if s.with_hose then
			p ' с присоединённым шлангом.'
		else
			p '.'
		end
	end;
	act = 'Старинный гидрант для подачи воды.';
	used = function(s, w)
		if w == firehose and not s.with_hose then
			s.with_hose = true
			remove(firehose, me())
			objs('fork'):add('fo_hose')
			p 'Я присоединил рукав пожарного шланга к гидранту и раскатал его вдоль дороги к фонтану.'
		elseif w == wrench and not s.with_water then
			if s.with_hose then
				s.with_water = true
				remove(wrench, me())
				p 'Я открутил гайку разводным ключом и почувствовал, как вода наполнила шланг.'
			else
				p 'Если в гидранте есть вода, и я отвинчу гайку, то вода сразу обольёт меня с головы до ног. Нет уж!'
			end
		end
	end
};

near_police_newspaper = room {
	nam = 'Таинственное исчезновение';
	pic = 'gfx/near_police/newspaper.jpg';
	dsc = [[
		У меня возникает ощущение, как будто я попал в прошлое...^
		{back|Закрыть}
	]];
	obj = { 
		xact('back', code[[goto('near_police');]])
	};	
};

-- КУЗОВ ГРУЗОВИКА
truck_body = room {
	nam = 'Кузов грузовика';
	pic = function(s)
		if tb_lock.open then
			if taken('bag') then
				local pict = 'gfx/near_police/truck_body/empty.jpg'
				if not truck_body_zodiak.taken then
					pict = pict..';gfx/near_police/truck_body/zodiak.jpg@148,6'
				end
				return pict
			elseif bag.with_holes then
				return 'gfx/near_police/truck_body/bag.jpg'
			else
				return 'gfx/near_police/truck_body/bag_patched.jpg'
			end
		else
			return 'gfx/near_police/truck_body/0.jpg'
		end
	end;
	obj = { 
		'tb_lock'
	};
	way = { 'near_police' };
};

tb_lock = obj {
	nam = 'замок';
	var {
		open = false
	};
	dsc = function(s)
		if not s.open then
			p 'Кузов грузовика закрыт на большой висячий {замок}.' 
		else
			p 'Кузов грузовика {открыт}.' 
		end
	end;
	act = function(s)
		if not s.open then
			p 'Интересно, что в кузове?'
		else
			p 'Этот грузовик служил для перевозки продуктов. Да, продукты бы не помешали, но боюсь, что ничего съедобного тут уже не осталось.'
		end
	end;
	used = function(s, w)
		if not s.open then
			if w == revolver then
				s.open = true
				objs():add('bag')
				remove('revolver', me())
				p 'Я выпустил одну за другой все пули, пока, наконец, не перебил дужку замка.'
			elseif w == axe then
				p 'Нет, топор здесь не поможет.'
			end
		end
	end;
};

-- ПОЛИЦЕЙСКИЙ УЧАСТОК
police_station = room {
	nam = 'Полицейский участок';
	pic = function(s)
		local pict = 'gfx/police/0.jpg'
		if ps_darts.num_darts > 0 then
			if ps_darts.num_darts == 3 then
				if taken('dial') then
					pict = pict..';gfx/police/darts_fall2.jpg@199,48'
				else
					pict = pict..';gfx/police/darts_fall.jpg@197,47'
				end
			else
				pict = pict..';gfx/police/darts.jpg@202,45'
			end
		end
		if ps_telephone.with_dial then
			pict = pict..';gfx/police/dial.jpg@47,69'
		end
		return pict
	end;
	dsc = [[
		В комнате разгром, столы и стулья опрокинуты... 
		Каменная стена проломлена мощным тараном грузовика. 
	]];
	obj = { 
		'ps_truck',
		'ps_safe',
		'ps_boxes',
		'ps_darts',
		'ps_telephone',
		'ps_helmet',
	};
	way = { 'near_police', 'truck_cabin' };
};

ps_truck = obj {
	nam = 'грузовик';
	dsc = [[
		Кабина грузовика взгромоздилась на груде кирпичей как 
		голова сюрреалистического {чудовища}...
	]];
	act = 'Может быть, весь этот кошмар мне просто снится?';
};

ps_safe = obj {
	nam = 'сейф';
	dsc = 'На полу валяется перевёрнутый {сейф}.';
	act = 'Металлический сейф закрыт.';
};

ps_boxes = obj {
	nam = 'шкаф с ящиками';
	dsc = 'У дальней стены стоит шкаф с полицейскими {записями}.';
	act = 'Я выбрал наугад и просмотрел пять карточек: это сведения о пропажах жителей городка, все они датированы 1919 годом.';
};

ps_darts = obj {
	nam = 'дартс';
	var {
		num_darts = 0	-- количество дротиков в мишени
	};
	dsc = 'Над шкафом -- мишень для {дартс}.';
	act = 'Наверное, это самая популярная игра у всех полицейских.';
	used = function(s, w)
		if w == red_dart then
			s.num_darts = s.num_darts + 1
			remove('red_dart', me())
			p 'Прицелившись, я бросил дротик в мишень. Отличный бросок!'
		elseif w == green_dart then
			s.num_darts = s.num_darts + 1
			remove('green_dart', me())
			p 'Не глядя, я метнул дротик в цель. В этом деле важна постоянная практика!'
		elseif w == blue_dart then
			s.num_darts = s.num_darts + 1
			remove('blue_dart', me())
			p 'Я бросил дротик церез плечо. Неплохо, но когда-то я кидал их лучше!'
		end
		if s.num_darts == 3 then
			objs():add('dial')
			p 'Мишень свалилась, и на стене...'
		end
	end
};

ps_telephone = obj {
	nam = 'телефон';
	var {
		with_dial = false
	};
	dsc = 'Слева висит старинный {телефонный аппарат}.';
	act = function(s)
		if not s.with_dial then
			p 'Без наборного диска не позвонишь. Да и куда мне звонить?'
		else
			p 'Наборный диск на месте, но вопрос, куда звонить, остался.'
		end
	end;
	used = function(s, w)
		if w == dial and not s.with_dial then
			s.with_dial = true
			remove('dial', me())
			p 'Я вставил наборный диск на своё место.'
		end
	end
};

ps_helmet = obj {
	nam = 'полицейская каска';
	var {
		zodiak_taken = false
	};
	dsc = 'Под ним на стуле лежит {полицейская каска}.';
	act = function(s)
		if not s.zodiak_taken then
			s.zodiak_taken = true
			take_zodiak('Под каской я нашёл фишку со знаком зодиака.')
		else
			p 'Прочная и стильная каска с кокардой.';
		end
	end
};

-- КАБИНА ГРУЗОВИКА
-- выдает 1 предмет за 1 заход
-- при первом заходе ничего не выдает
truck_cabin = room {
	nam = 'Кабина грузовика';
	var {
		thing_taken = false,
		first_enter = true
	};
	enter = function(s)
		s.thing_taken = false
	end;
	exit = function(s)
		s.first_enter = false
	end;
	pic = 'gfx/police/truck_cabin.jpg';
	dsc = [[
		Да это не кабина, а музей ненужных вещей! 
		Хотя, быть может, и я найду здесь что-нибудь полезное.
	]];
	act = function(s, w)
		if not s.first_enter then
			if w == 'чемодан' and not taken('needle') and not s.thing_taken then
				s.thing_taken = true
				take('needle')
				return 'В чемодане я нашёл катушку ниток с иголкой.'
			end
			if w == 'бардачок' and not taken('pendant_2') and not s.thing_taken then
				s.thing_taken = true
				take('pendant_2')
				return 'В бардачке я нашёл половинку кулона.'
			end
		end
		return ('Я осмотрел '..w..' и ничего не нашёл.')
	end;
	obj = { 
		vobj('кабину',   'Осмотреть {кабину}.^'),
		vobj('чемодан',  'Осмотреть {чемодан}.^'),
		vobj('бардачок', 'Осмотреть {бардачок}.^'),
	};
	way = { 'police_station' };
};

-- РЯДОМ С ОСОБНЯКОМ
near_house = room {
	nam = 'Особняк';
	pic = function(s)
		local pict = 'gfx/near_house/0.jpg'
		if dry_roses.cut then
			pict = pict..';gfx/near_house/roses_cut.jpg@263,224'
			if taken('key_cross') then
				pict = pict..';gfx/near_house/key_taken.jpg@262,266'
			end
		end
		return pict		
	end;
	dsc = [[
		Передо мной возвышается солидное двухэтажное здание. 
		Возможно, это и есть дом мэра.
		Все окна забраны {fortress|решётками}. 
	]];
	obj = { 
		xact('fortress', 'Мой дом -- моя крепость.'),
		'nh_door',
		'nh_flower_bed',
		'nh_statue',
	};
	way = { 'near_police', 'front_side', 'lateral_side' };
};

nh_door = obj {
	nam = 'дверь';
	dsc = 'Полукруглое крыльцо ведёт к парадному {входу}.';
	act = 'Окованные железом двери закрыты. Я постучал кулаком, затем поколотил в дверь ногой -- ответом мне была тишина.';
	used = function(s, w)
		if w == axe then
			p 'Такие двери топором не возьмёшь, тут нужен автоген.'
		end
	end;
};

nh_window = obj {
	nam = 'окно';
	dsc = 'В окне второго этажа какой-то {свет}? ';
	act = 'Или мне это чудится?';
};

nh_flower_bed = obj {
	nam = 'цветочная клумба';
	dsc = 'Перед входом расположена цветочная {клумба}.';
	act = function(s)
		if not dry_roses.cut then
			p 'Раскидистый куст когда-то радовал глаз.'
		elseif not taken('key_cross') then
			take('key_cross')
			p 'Я достал из клумбы какой-то странный предмет.'
		else						
			p 'Больше в клумбе ничего интересного нет.'
		end
	end;
	obj = {
		'dry_roses'
	};
};

nh_statue = obj {
	nam = 'статуя';
	var {
		first = true
	};
	dsc = 'На постаменте, рядом с фонарем, стоит {статуя}.';
	act = function(s)
		if s.first then
			s.first = false
			objs():add('nh_statue_panel')
			p 'Разглядев внимательно постамент, я заметил панель.'
		else
			p 'Женщина-ангел присела отдохнуть и поправить волосы.'
		end
	end;
};

nh_statue_panel = obj {
	nam = 'панель';
	dsc = 'В основании постамента имеется {панель}.';
	act = 'Панель шатается, но не поддаётся.';
};

-- ФРОНТАЛЬНАЯ СТОРОНА
front_side = room {
	nam = 'Фронтальная сторона';
	pic = 'gfx/front_side/0.jpg';
	dsc = [[
		Кругом видны признаки ужасного запустения.
	]];
	obj = { 
		'fs_bush',
		'fs_lantern',
		'fs_roadway',
		vway('fs_map', 'На земле валяется {рисунок}.', 'front_side_map'),
	};
	way = { 'near_house', 'cellar_door', 'park_start' };
};

fs_bush = obj {
	nam = 'кустарник';
	dsc = '{Кустарники} разрослись и оплели фасад здания.';
	act = 'Их очень давно никто не обрезал.';
	used = function(s, w)
		if w == secateur then
			p 'Мне некогда заниматься этим, у меня есть более важные дела!'
		end
	end
};

fs_lantern = obj {
	nam = 'фонарь';
	dsc = 'Фонарь {изогнут}, его обломки валяются на земле.';
	act = 'Чтобы сделать такое, нужна поистине нечеловеческая сила!';
};

fs_roadway = obj {
	nam = 'мостовая';
	dsc = 'Отдельные плитки выворочены из мостовой и разбросаны {как попало}.';
	act = 'Куда же делись слуги, садовник? Не могли же они все разом исчезнуть?';
};

front_side_map = room {
	nam = 'Рисунок';
	pic = 'gfx/front_side/map.jpg';
	dsc = [[
		Какой-то детский рисунок...^
		{back|Назад}
	]];
	obj = { 
		xact('back', code[[goto('front_side');]])
	};	
};

-- ДВЕРЬ В ПОДВАЛ
cellar_door = room {
	nam = 'Вход в подвал';
	pic = function(s)
		if not cd_tree_trunk.cut then
			p 'gfx/cellar_door/0.jpg'
		elseif not taken('branches') then
			p 'gfx/cellar_door/trunk_cut.jpg'
		elseif not cd_lock.open then
			if axe.broken_near_cellar then
				p 'gfx/cellar_door/branches_taken_axe.jpg'
			else
				p 'gfx/cellar_door/branches_taken.jpg'
			end
		else
			if axe.broken_near_cellar then
				p 'gfx/cellar_door/open_axe.jpg'
			else
				p 'gfx/cellar_door/open.jpg'
			end
		end
	end;
	obj = { 
		'cd_tree_trunk',
		'cd_lock'
	};
	way = { 'front_side' };
};

cd_tree_trunk = obj {
	nam = 'ветка дерева';
	var {
		cut = false
	};
	dsc = function(s)
		if cd_lock.open then
			p 'Вход в подвал открыт.'
		else
			p 'Вход в подвал преграждает'
			if not taken('branches') then
				p '{ветка} упавшего дерева и'
			end
		end
	end;
	act = function(s)
		if not s.cut then
			p 'Ветка крепкая, руками мне её не сломать.'
		elseif not taken('branches') then
			p 'Теперь мне мешают сучья.'
		end
	end;
	used = function(s, w)
		if w == axe then
			if not s.cut then
				s.cut = true
				p 'Я перерубил ветку, и она упала на землю.'
			elseif not taken('branches') then
				take('branches')
				-- если полицейска дверь уже прорублена, бросаем топор
				if np_door.broken then
					axe.broken_near_cellar = true
					remove('axe', me())
					p 'Я успел отрубить несколько мешавших мне сучьев, когда топорище сломалось. Вот досада!'
				else
					p 'Я отрубил несколько мешавших мне сучьев и взял их с собой.'
				end
			end
		end
	end;
};

cd_lock = obj {
	nam = 'замок';
	var {
		open = false
	};
	dsc = function(s)
		if not s.open then
			p 'железная решётка с {замком}.'
		end
	end;
	act = 'Интересная форма должна быть у этого ключа.';
	used = function(s, w)
		if not taken('branches') then
			p 'Я не могу подобраться к замку, мне мешают сучья.'
		elseif w == key_cross and not s.open then
			s.open = true
			remove('key_cross', me())
			ways():add('cellar')
			p 'Я вставил крестообразный ключ в замок, и решётка открылась.'
		end
	end;
};

-- ПОДВАЛ
-- сигнализирует, что в подвале появился новый предмет
local function new_thing_in_cellar()
	return (not taken('handsaw')) or
		(not taken('insect_net') and objs(house_upstairs):srch('hu_snake')) or
		(not taken('firehose') and zodiak_puzzle.solved)
end

-- единственная подсказка о новом предмете - добавляется текст в dsc
cellar = room {
	nam = 'Подвал';
	pic = 'gfx/cellar/0.jpg';
	dsc = function(s)
		p 'Подвал набит всяким хламом.'
		if new_thing_in_cellar() then
			p 'Однако и среди хлама можно найти что-нибудь полезное!'
		end
	end;
--		К сожалению, проход дальше преграждают толстые прутья решётки.
	act = function(s, w)
		if w == 'шкафчик' and not taken('handsaw') then
			take('handsaw')
			return 'Я осмотрел шкафчик и нашёл ножовку.'
		end
		if w == 'полку' and not taken('insect_net') and 
		   objs(house_upstairs):srch('hu_snake') then
			take('insect_net')
			return 'Я осмотрел полку и нашёл сачок.'
		end
		if w == 'ящики' and not taken('firehose') and
		   zodiak_puzzle.solved then
			take('firehose')
			return 'Я осмотрел ящики и в одном из них нашёл пожарный шланг.'
		end
		return ('Я осмотрел '..w..' и ничего не нашёл.')
	end;
	obj = { 
		vobj('полку',   'Осмотреть {полку}.^'),
		vobj('шкафчик', 'Осмотреть {шкафчик}.^'),
		vobj('ящики',   'Осмотреть {ящики}.^'),
	};
	way = { 'cellar_door' };
};

-- БОКОВАЯ СТОРОНА
lateral_side = room {
	nam = 'Боковая сторона';
	pic = function(s)
		if ls_lattice.cut then
			return 'gfx/lateral_side/lattice_cut.jpg'
		else
			return 'gfx/lateral_side/0.jpg'
		end
	end;
	obj = { 
		'ls_lattice'
	};
	way = { 'near_house' };
};

ls_lattice = obj {
	nam = 'решётка на окне';
	var {
		cut = false
	};
	dsc = function(s)
		if not s.cut then
			p 'Окно на первом этаже открыто, но на нём железные {решётки}.'
		else
			p 'Окно на первом этаже открыто, решётки распилены.'
		end
	end;
	act = function(s)
		if not s.cut then
			p 'Можно было бы попасть внутрь, но мне мешают решётки.'
		end
	end;
	used = function(s, w)
		if w == handsaw and not s.cut then
			s.cut = true
			remove('handsaw', me())
			ways():add('house_hall_ghost')
			return 'Мне пришлось изрядно попотеть, прежде чем удалось перепились решётки.'
		end
	end;
};

-- РАЗВИЛКА К ЦЕРКВИ и ПРИЧАЛУ
fork2church = room {
	nam = 'Развилка';
	pic = 'gfx/fork2church.jpg';
	dsc = [[
		Кругом туман. 
	]];
	way = { 'fork', 'way2church' };
};

-- ДОРОГА К ЦЕРКВИ
way2church = room {
	nam = 'Дорога к церкви';
	pic = function(s)
		return 'gfx/way2church.jpg'
	end;
	dsc = [[
		Мощёная мостовая ведёт к величественному зданию церкви. 
		По обеим сторонам дороги -- полуразвалившиеся домики. 
	]];
	obj = {
		'wc_teddy',
--		'wc_wheel',
	};
	way = { 'fork2church', 'near_church' };
};

wc_teddy = obj {
	nam = 'плюшевый мишка';
	var {
		cut = false
	};
	dsc = 'Слева у дороги лежит большой {плюшевый мишка}.';
	act = 'Если бы я был ребёнком, я бы обязательно спрятал свои сокровища в любимом медвежонке.';
	used = function(s, w)
		if w == scalpel and not s.cut then
			s.cut = true
			take('key_teddy')
			remove('scalpel', me())
			p 'Я аккуратно разрезал плюшевому мишке брюхо и нашёл в нём ключик.'
		end
	end
};

wc_wheel = obj {
	nam = 'колесо';
	dsc = 'Там же валяется колесо от велосипеда, у которого сохранилась целая {шестерёнка}.';
	act = 'Голыми руками мне эту шестерёнку не снять.';
};

-- У ЦЕРКВИ
near_church = room {
	nam = 'У церкви';
	pic = function(s)
		local pict = 'gfx/near_church/0.jpg'
		if nc_door.open then
			pict = pict..';gfx/near_church/door.jpg@77,119'
		end
		if nc_tablet.state == nc_tablet.ST_PAPER then
			pict = pict..';gfx/near_church/paper.jpg@338,256'
		elseif nc_tablet.state == nc_tablet.ST_COAL then
			pict = pict..';gfx/near_church/paper_coal.jpg@338,260'
		end
		return pict
	end;
	dsc = [[
		Я перед входом в церковь. Здесь пустынно.
	]];
	obj = {
		'nc_door',
		'nc_tablet',
		vway('фото с сестрой', 'Прямо на земле лежит {фотография}.', 'near_church_photo'),
		'nc_cemetery',
	};
	way = { 'way2church' };
};

nc_door = obj {
	nam = 'дверь в церковь';
	var {
		open = false
	};
	dsc = function(s)
		if not s.open then
			p 'Массивные двери преграждают вход; на двери {замок}.'
		else
			p 'Массивные двери открыты.'
		end
	end;
	act = 'Закрыто -- ну кто бы сомневался!';
	used = function(s, w)
		if not s.open then 
			if w == key_church then 
				s.open = true
				remove('key_church', me())
				ways():add('church_ghost')
				p 'Я вставил ключ и открыл дверь.'
			elseif w == key_teddy or w == key_cross then
				p 'Этот ключ здесь не подойдёт.'
			end
		end
	end
};

nc_tablet = obj {
	nam = 'табличка';
	-- константы состояний
	ST_EMPTY = 0;		-- не разобрать (начальное)
	ST_PAPER = 1;		-- приложен листок
	ST_COAL = 2;		-- обработали угольком
	var {
		state = 0		-- текущее состояние
	};
	dsc = 'Перед входом стоит каменная тумба с железной {табличкой}.';
	act = function(s)
		if s.state == s.ST_EMPTY then
			p 'Здесь что-то выгравировано... Не могу разобрать.'
		elseif s.state == s.ST_PAPER then
			p 'К табличке с гравировкой приложен листок бумаги.'
		elseif s.state == s.ST_COAL then
			goto (near_church_paper_coal)		
		end
	end;
	used = function(s, w)
		if s.state == s.ST_EMPTY then
			if w == paper then
				s.state = s.ST_PAPER
				remove('paper', me())
				p 'Я приложил лист бумаги к надписи на табличке.'
			end
		elseif s.state == s.ST_PAPER then
			if w == coal then
				s.state = s.ST_COAL
				remove('coal', me())
				p 'Старый способ с углём сработал: на бумаге осталась довольно чёткая надпись.'
			end
		end
	end
};

nc_cemetery = obj {
	nam = 'кладбище';
	dsc = 'Позади церкви расположено старинное {кладбище}.';
	act = 'Вообще-то я не любитель ходить по кладбищам...';
};

near_church_photo = room {
	nam = 'Фото с сестрой';
	pic = 'gfx/near_church/photo.jpg';
	dsc = [[
		Это мы с сестрой прошлым летом. Я ещё не успел познакомить
		её с Энжел. Интересно, как здесь оказалось это фото?
		Не припомню, чтобы нас кто-то фотографировал...
		^^
		{back|Закрыть}
	]];
	obj = { 
		xact('back', code[[goto('near_church');]])
	};	
};

near_church_paper_coal = room {
	nam = 'Надпись на табличке';
	pic = 'gfx/near_church/paper_coal_big.jpg';
	dsc = [[
		Латынь. Вполне предсказуемо.
		^{back|Закрыть}
	]];
	obj = { 
		xact('back', code[[goto('near_church');]])
	};	
};

-- ЦЕРКОВЬ (одноразовая)
church_ghost = room {
	nam = 'Церковь';
	pic = 'gfx/church/ghost.jpg';
	hideinv = true;
	dsc = [[
		Слава Богу, хоть одна живая душа! 
		^^ 
		{next|Нет, опять наваждение...}
	]];
	obj = { 
		xact('next', 
			code[[
			ways(near_church):replace(church_ghost, church);
			goto(church);
			]])
	};
};

-- ЦЕРКВЬ
church = room {
	nam = 'Церковь';
	pic = function(s)
		local pict = 'gfx/church/0.jpg'
		if ch_stained.state ~= ch_stained.ST_DIRTY then
			if ch_stained.state == ch_stained.ST_CLEAN then
				pict = pict..';gfx/church/stained_clean.jpg@407,0'
			elseif ch_stained.state == ch_stained.ST_CLICHE then
				pict = pict..';gfx/church/stained_cliche.jpg@406,0'
			elseif ch_stained.state == ch_stained.ST_CLICHE_LIGHT then
				pict = pict..';gfx/church/stained_cliche_light.jpg@220,0'
			end
			if not taken('book_1898') then
				pict = pict..';gfx/church/book.jpg@421,151'
			end
		end
		return pict
	end;
	dsc = [[
		Я внутри церкви. Когда-то это было строгое и величественное 
		сооружение; сейчас здесь опасно находиться. 
		Некоторые потолочные балки рухнули вместе с колоколом.
	]];
	obj = {
		'ch_bell',
		'ch_washstand',
		'ch_floor',
		'ch_stained',
	};
	way = { 'near_church', 'church_altar' };
};

ch_bell = obj {
	nam = 'колокол';
	dsc = 'Огромный {колокол} от удара раскололся.';
	act = 'Звук этого колокола наверняка был слышен на всём острове.';
};

ch_washstand = obj {
	nam = 'умывальник';
	dsc = 'Слева в стене умывальник, из которого течёт {вода}.';
	act = 'Пить эту воду я бы не стал, а вот руки вымыть можно.';
	used = function(s, w)
		if w == handkerchief then 
			handkerchief.wet = true
			p 'Я намочил платок водой.'
		end
	end
};

ch_floor = obj {
	nam = 'пол';
	var {
		pressed = false		-- нажал на плиты, освещённые лучами света?
	};
	dsc = 'Несколько больших каменных {плиток} выступают посреди пола.';
	act = function(s)
		if ch_stained.state ~= ch_stained.ST_CLICHE_LIGHT then
			p 'Я споткнулся и чуть не подвернул себе ногу. И кто только придумал расположить эту странную конструкцию прямо под ногами?'
		else
			s.pressed = true
			p 'Я поочерёдно наступил на плиты, на которые падает свет, и алтарь слегка отодвинулся, открывая люк.'
		end
	end
};

ch_stained = obj {
	nam = 'витраж';
	-- константы состояний
	ST_DIRTY = 0;			-- грязный (начальное)
	ST_CLEAN = 1;			-- вымыт
	ST_CLICHE = 2;			-- наложен трафарет
	ST_CLICHE_LIGHT = 3;	-- через трафарет идёт свет
	var {
		state = 0 			-- текущее состояние
	};
	dsc = 'Справа на стене большой {витраж}.';
	act = function(s)
		if s.state == s.ST_DIRTY then
			p 'Витраж весь в грязи и пыли, изображение трудно рассмотреть.'
		else
			goto(church_stained_glass)
		end
	end;
	used = function(s, w)
		if s.state == s.ST_DIRTY then
			if w == handkerchief then 
				if handkerchief.wet then
					s.state = s.ST_CLEAN
					remove('handkerchief', me())
					objs():add('book_1898')
					p 'Я стёр грязь мокрым платком, и витраж заиграл яркими красками. Теперь его можно рассмотреть.'
				else
					p 'Не-е-ет, такую грязь сухим платочком не возьмёшь.'
				end
			end
		elseif s.state == s.ST_CLEAN then
			if w == cliche then
				if maria_diary.seen then
					s.state = s.ST_CLICHE
					remove('cliche', me())
					p 'Я наложил трафарет на витраж.'
				else
					p 'Мысль интересная, но я не знаю, куда приложить трафарет.'
				end
			end
		elseif s.state == s.ST_CLICHE then
			if w == ring then
				s.state = s.ST_CLICHE_LIGHT
				remove('ring', me())
				p 'Я аккуратно вырезал в витраже отверстия по трафарету. Свет проник внутрь церкви и упал на плиты.'
			end
		end
	end
};

church_stained_glass = room {
	nam = 'Витраж';
	var {
		msg_one = true
	};
	pic = function(s)
		local pict = 'gfx/church/stained_glass/0.jpg'
		if ch_stained.state == ch_stained.ST_CLICHE then
			pict = pict..';gfx/church/stained_glass/cliche.jpg@86,321'
		elseif ch_stained.state == ch_stained.ST_CLICHE_LIGHT then
			pict = pict..';gfx/church/stained_glass/cliche_light.jpg@1,321'
		end
		return pict
	end;
	dsc = function(s)
		if ch_stained.state ~= ch_stained.ST_CLICHE then
			p 'Какой прекрасный и умиротворённый образ.'
		else
			p_12(s, 'Отлично! Трафарет подошёл как на рисунке. Что дальше?',
				'Думаю, что стоит вырезать эти кусочки стекла.')
		end
		p '^{back|Закрыть}'
	end;
	obj = { 
		xact('back', code[[goto('church');]])
	};	
};

-- АЛТАРЬ
church_altar = room {
	nam = 'Алтарь';
	var {
		hatch_opened = false
	};
	enter = function(s, from)
		if altar_puzzle.solved and not s.hatch_opened then
			s.hatch_opened = true
			objs():add('hammer')
			p 'Механизм замка щёлкнул и открыл секретный люк.'
		end
	end;
	pic = function(s)
		local pict = 'gfx/church/altar/0.jpg'
		if ch_floor.pressed then
			pict = 'gfx/church/altar/hatch_closed.jpg'
			if s.hatch_opened then
				if taken('hammer') then
					pict = pict..';gfx/church/altar/hatch_opened.jpg@117,223'
				else
					pict = pict..';gfx/church/altar/hatch_opened_hammer.jpg@117,223'
				end
			end
		end
		return pict
	end;
	obj = {
		'al_hatch',
		'al_cloth',
	};
	way = { 'church' };
};

al_hatch = obj {
	nam = 'алтарь-люк';
	dsc = function(s)
		p 'Я нахожусь в восточной части церкви.'
		if not ch_floor.pressed then
			p 'Передо мною простой каменный {алтарь};'
		elseif not altar_puzzle.solved then
			p 'Алтарь, оказывается, скрывал {секретный люк}!'
		end
	end;
	act = function(s)
		if not ch_floor.pressed then
			p 'Если честно, алтарь не произвёл на меня никакого впечатления.'
		elseif not altar_puzzle.solved then
			goto('altar_puzzle') 
		end
	end
};

al_cloth = obj {
	nam = 'полотнище';
	dsc = function(s)
		if not ch_floor.pressed then
			if not taken('sun') then 
				p 'сверху лежит кусок грубого {синего полотнища}, по бокам стоят подсвечники.'
			else
				p 'сверху лежит кусок грубого синего полотнища, по бокам стоят подсвечники.'
			end
		end
	end;
	act = function(s)
		if not taken('sun') then
			take('sun')
			p 'Приподняв полотнище, я обнаружил диск в форме Солнца.'
		end
	end
};

-- ФИНАЛЬНАЯ ЛОКАЦИЯ
final = room {
	nam = 'Конец';
	hideinv = true;
	pic = 'gfx/final.jpg';
	dsc = [[
		Поздравляю, Вы достигли финальной локации!
		Немного жаль, но всё хорошее когда-нибудь заканчивается. 
		Благодарю Вас за проявленные терпение и настойчивость. :)
 		^^
		Автор (обработка графики, тексты, мини-игры): NasPolkovnik
		^^
		Благодарности:^
		-- Alawar Stargaze -- за графику и оригинальный сюжет;^
		-- Петру Косых -- за INSTEAD (it's amazing!), Кота и Кубу;^
		-- В.Подобаеву -- за Escape the Toilet;^
		-- Jhekasoft -- за Лифтёров;^
		-- tturgor -- за Рикки-Тикки-Тави;^
		-- всем авторам, пишущим замечательные игры...
		^^
		{back|Вернуться на остров}
	]];
	obj = {
		xact('back', code[[goto(fork);]])
	};
};
