-- ВСЕ ЛОКАЦИИ ВНУТРИ ОСОБНЯКА ЗДЕСЬ

-- ХОЛЛ ОСОБНЯКА (одноразовый)
house_hall_ghost = room {
	nam = 'Холл';
	pic = 'gfx/house/hall/ghost.jpg';
	hideinv = true;
	dsc = [[
		Женщина -- та самая, из объявления! 
		Она протягивает ко мне руку, будто просит о чём-то...
		^^ 
		{next|Мадам, я и в мыслях не имел...}
	]];
	obj = { 
		xact('next', 
			code[[
			ways(lateral_side):replace(house_hall_ghost, house_hall);
			goto(house_hall);
			]])
	};
	exit = 'Пропала! Чёрт, опять померещилось!';
};

-- ХОЛЛ ОСОБНЯКА
house_hall = room {
	nam = 'Холл';
	var {
		first_big_fire = true,		-- флаги для однократных сообщений
		first_ash = true
	};
	enter = function(s)
		if s.first_big_fire and fp_fire.state == fp_fire.ST_BIG_FIRE then
			s.first_big_fire = false
			ways():add('house_hall_wall')
			return 'Сквозняк? Странно, дым не должен так себя вести. С этой стеной что-то не так.'
		end
		if s.first_ash and fp_fire.state == fp_fire.ST_BIG_FIRE then
			-- переключаемся на ST_ASH, если нашли диск солнца
			if taken('sun') then
				s.first_ash = false
				fp_fire.state = fp_fire.ST_ASH
				objs('fp_fire'):add('coal')
				return 'Камин уже погас? Странно.'
			end
		end
	end;
	pic = function(s)
		local pict = 'gfx/house/hall/nofire.jpg'
		if fp_fire.state == fp_fire.ST_SMALL_FIRE then
			pict = 'gfx/house/hall/small_fire.jpg'
		elseif fp_fire.state == fp_fire.ST_BIG_FIRE then
			pict = 'gfx/house/hall/big_fire.jpg'
		end
		if hh_table.open then
			if taken('revolver') then
				pict = pict..';gfx/house/hall/box_empty.jpg@240,214'
			else
				pict = pict..';gfx/house/hall/box_revolver.jpg@242,215'
			end
		end
		return pict
	end;
	dsc = function(s)
		p [[
			Я в холле богатого особняка. 
			По всему видно, что дом заброшен уже давно: 
			на потолке трещины и подтёки. 
		]];
		if fp_fire.state ~= fp_fire.ST_BIG_FIRE then
			p 'Холодно-то как!!!'
		end
	end;
	obj = { 
		'hh_antic',
		'hh_table',
		vway('книга', 'Рядом на полу лежит раскрытая {книга}.', 'house_hall_poison_book'),
		'hh_picture',
		vway('камин', 'Рядом стоит {камин}.', 'house_hall_fireplace'),
	};
	way = { 'lateral_side' , 'house_upstairs' };
};

hh_antic = obj {
	nam = 'антикварная мебель';
	dsc = 'В комнате много хорошо сохранившейся старинной {мебели}.';
	act = 'Вот за это я и люблю антикварную мебель. Столько лет стоит -- и хоть бы что ей сделалось!';
};

hh_table = obj {
	nam = 'стол';
	var {
		open = false
	};
	dsc = 'На изящном столе с выдвижным {ящиком} стоят кофейные чашечки.';
	act = function(s)
		if not s.open then
			s.open = true
			p 'Я выдвинул ящик, в нём оказался револьвер.'
		elseif not taken('revolver') then
			take('revolver')
			p 'Я достал из ящика револьвер и осмотрел его: он заряжен.'
		else
			p 'Больше в ящике ничего нет.'
		end
	end
};

hh_picture = obj {
	nam = 'картина';
	dsc = 'На дальней стене висит огромный {портрет}.';
	act = 'Владелец особняка, наверное, очень любил свою жену. Ну, или она себя очень любила.';
};

house_hall_poison_book = room {
	nam = 'Книга';
	pic = 'gfx/house/hall/poison_book.jpg';
	dsc = [[
		Познавательный... текст.
		^^
		{back|Закрыть}
	]];
	obj = { 
		xact('back', code[[goto('house_hall');]])
	};	
};

-- КАМИН
house_hall_fireplace = room {
	nam = 'Камин';	
	pic = function(s)
		if fp_fire.state == fp_fire.ST_NOFIRE then
			return 'gfx/house/hall/fireplace/1_nofire.jpg'
		elseif fp_fire.state == fp_fire.ST_ROSES then
			return 'gfx/house/hall/fireplace/2_roses.jpg'
		elseif fp_fire.state == fp_fire.ST_SMALL_FIRE then
			return 'gfx/house/hall/fireplace/3_small_fire.jpg'
		elseif fp_fire.state == fp_fire.ST_BIG_FIRE then
			return 'gfx/house/hall/fireplace/4_big_fire.jpg'
		elseif fp_fire.state == fp_fire.ST_ASH then
			return 'gfx/house/hall/fireplace/5_ash.jpg'
		end
	end;
	obj = {
		'fp_fire',
	};
	way = { 'house_hall' };
};

fp_fire = obj {
	nam = 'огонь';
	-- константы состояний
	ST_NOFIRE = 0;		-- огня нет (начальное)
	ST_ROSES = 1;		-- положены сухие розы
	ST_SMALL_FIRE = 2;	-- розы подожжены
	ST_BIG_FIRE = 3;	-- добавлены сучья
	ST_ASH = 4;			-- кучка золы
	var {
		state = 0		-- текущее состояние
	};
	dsc = function(s)
		if s.state == s.ST_NOFIRE then
			p 'В {камине} огня нет. Холодно!'
		elseif s.state == s.ST_ROSES then
			p 'В камине лежат {cухие розы}, огня нет.'
		elseif s.state == s.ST_SMALL_FIRE then
			p 'В камине горит небольшой {огонь}.'
		elseif s.state == s.ST_BIG_FIRE then
			p 'В камине горит большой яркий {огонь}.'
		elseif s.state == s.ST_ASH then
			p 'В {камине} большая куча золы. '
		end
	end;
	act = function(s)
		if s.state == s.ST_NOFIRE then
			p 'Нужно что-нибудь сухое, чтобы разжечь огонь и согреться.'
		elseif s.state == s.ST_ROSES then
			p 'Растопка у нас уже есть.'
		elseif s.state == s.ST_SMALL_FIRE then
			p 'Огонь маленький, не могу согреться.'
		elseif s.state == s.ST_BIG_FIRE then
			p 'Вот теперь хорошо!'
		elseif s.state == s.ST_ASH then
			p 'Странно, неужели я так долго здесь уже нахожусь?'
		end
	end;	
	used = function(s, w)
		if s.state == s.ST_NOFIRE then
			if w == dry_roses then
				s.state = s.ST_ROSES
				remove('dry_roses', me())
				p 'Я положил засохшие розы в камин.'
			elseif w == branches then
				p 'Нужно что-то помельче.'
				return false
			elseif w == lighter then
				p 'Сначала нужно что-нибудь для растопки.'
				return false
			end
		elseif s.state == s.ST_ROSES then
			if w == lighter then
				s.state = s.ST_SMALL_FIRE
				p 'Я поджёг сухие розы, пламя весело затрещало.'
			elseif w == branches then
				p 'Если я положу сучья, мне будет трудно разжечь огонь.'
				return false
			end
		elseif s.state == s.ST_SMALL_FIRE then
			if w == branches then
				s.state = s.ST_BIG_FIRE
				remove('branches', me())
				p 'Я подбросил сухие сучья в камин, и огонь разгорелся ярким пламенем.'
			end
		end
	end
};

-- СТЕНА в ХОЛЛЕ (c тайником)
house_hall_wall = room {
	nam = 'Стена';
	enter = function()
		if zodiak_puzzle.solved then
			disable('hw_jib_door_panel')
		end		
	end;
	pic = function(s)
		if hw_wallpaper.cut then
			if zodiak_puzzle.solved then
				return 'gfx/house/hall/wall/door_opened.jpg'
			elseif hw_jib_door_panel.zodiak_inserted then
				return 'gfx/house/hall/wall/zodiak_inserted.jpg'
			else
				return 'gfx/house/hall/wall/wallpaper_cut.jpg'
			end
		else
			return 'gfx/house/hall/wall/0.jpg'
		end
	end;
	dsc = function(s)
		if not hw_wallpaper.cut then
			p 'На вид стена как стена. Но почему к ней тянется дым?'
		end
	end;
	obj = { 
		'hw_wallpaper'	-- потом будет заменена на hw_jib_door
	};
	way = { 'house_hall' };
};

hw_wallpaper = obj {
	nam = 'обои';
	var {
		cut = false
	};
	dsc = 'Стену закрывают {обои}.';
	act = 'Какие-то они странные.';
	used = function(s, w)
		if not s.cut then
			if w == scalpel then
				s.cut = true
				replace('hw_wallpaper', 'hw_jib_door', house_hall_wall)
				p 'Сейчас мы их скальпелем... О-ля-ля, да здесь тайник!'
			elseif w == lighter then
				p 'Поджечь обои и устроить пожар? Нет уж!'
				return false
			end
		end
	end
};

hw_jib_door = obj {
	nam = 'потайная дверь';
	var {
		msg_one = true
	};
	dsc = function(s)
		if not zodiak_puzzle.solved then
			p 'Передо мной находится потайная {дверь}.'
		else
			p 'Потайная дверь {открыта}.'
		end
	end;
	act = function(s)
		if not zodiak_puzzle.solved then
			p_12(s, 'Где тайник, там ответы на вопросы. А у меня уже накопилось слишком много вопросов.',
				'Как же её открыть?')
		else
		   goto(hiding_place)
		end
	end;
	obj = {
		'hw_jib_door_panel',
	};
};

hw_jib_door_panel = obj {
	nam = 'панель';
	var {
		zodiak_inserted = false
	};
	dsc = 'Справа в стене -- {панель с гнёздами} для фишек.';
	act = function(s)
		if not s.zodiak_inserted then
			return 'Верхнее гнездо занято; остальные 4 фишки отсутствуют.'
		elseif not zodiak_puzzle.solved then
			goto('zodiak_puzzle') 
		end
	end;
	used = function(s, w)
		if w == zodiak and not s.zodiak_inserted then
			if zodiak.cnt < zodiak.NEED_CNT then
				p 'Сначала надо найти все фишки.'
			else
				s.zodiak_inserted = true
				remove('zodiak', me())
				p 'Я вставил найденные фишки со знаками зодиака в гнёзда, и панель сдвинулась вверх.'
			end
		end
	end
};

-- ТАЙНИК
hiding_place = room {
	nam = 'Тайник';
	pic = function(s)
		if not taken('wrench') then
			return 'gfx/house/hall/wall/hiding_place.jpg'
		else
			return 'gfx/house/hall/wall/hiding_place_2.jpg'
		end
	end;
	obj = { 
		'hp_revolver',
		'wrench',
		'hp_photo',
	};
	way = { 'house_hall_wall' };
};

hp_revolver = obj {
	nam = 'револьвер';
	dsc = 'На полу лежат: мужская шляпа, перчатки, {револьвер},';
	act = 'Старый ржавый револьвер, без патронов.';
};

hp_photo = obj {
	nam = 'фото';
	dsc = 'несколько старых {фотографий}.';
	act = 'Женщина похожа на хозяйку дома, а вот кто мужчина?';
};

-- ЛЕСТНИЦА НАВЕРХ
house_upstairs = room {
	nam = 'Лестница';
	pic = function(s)
		local pict = 'gfx/house/upstairs/0.jpg'
		if hu_door.open then
			pict = pict..';gfx/house/upstairs/door_open.jpg@209,29'
			if hu_snake.state == hu_snake.ST_UNDER_NET then
				pict = pict..';gfx/house/upstairs/under_net.jpg@217,122'
			elseif hu_snake.state == hu_snake.ST_CAUGHT then
				pict = pict..';gfx/house/upstairs/in_bag.jpg@214,127'
			end
		end
		if hu_ball_1.oiled then
			pict = pict..';gfx/house/upstairs/ball_left.jpg@21,121'
		end
		if hu_ball_2.oiled then
			pict = pict..';gfx/house/upstairs/ball_middle.jpg@189,121'
		end
		if hu_balls.open then
			if taken('key_church') then
				pict = pict..';gfx/house/upstairs/step_open_key_taken.jpg@331,224'
			else
				pict = pict..';gfx/house/upstairs/step_open.jpg@331,224'
			end
		end
		return pict
	end;
	dsc = [[
		Я нахожусь на лестнице, ведущей на второй этаж. 
		Тусклый лунный свет освещает площадку.
	]];
	obj = { 
		'hu_door',
		'hu_guns',
		vway('шахта', 'Над ними -- вентиляционная {шахта}.', 'hu_vent_mine'),
		'hu_balls',
		'hu_ball_1',
		'hu_ball_2',
		'hu_ball_3'
	};
	enter = function(s)
		disable_balls()
	end;
	exit = function(s, to)
		if to == hu_vent_mine then
			if hu_snake.state == hu_snake.ST_FREE then
				p 'Я не могу это сделать -- рядом змея!'
				return false
			elseif hu_snake.state == hu_snake.ST_UNDER_NET then
				p 'Я не могу это сделать, я держу змею.'
				return false
   			end
		elseif to == house_hall and hu_snake.state == hu_snake.ST_UNDER_NET then
			hu_snake.state = hu_snake.ST_FREE
			take('insect_net')
			p 'Устав удерживать змею, я сдернул сачок и отступил вниз по лестнице.'
		end
	end;
	way = { 'house_hall' };
};

function disable_balls()
	disable('hu_ball_1')
	disable('hu_ball_2')
	disable('hu_ball_3')
end

function enable_balls()
	enable('hu_ball_1')
	enable('hu_ball_2')
	enable('hu_ball_3')
end

hu_door = obj {
	nam = 'дверь';
	var {
		open = false
	};
	dsc = 'Площадка ведёт в комнату, вход в которую закрывает {дверь}.';
	act = function(s)
		s.open = true
	    replace('hu_door', 'hu_snake', house_upstairs)
	    hu_snake.state = hu_snake.ST_FREE
		p 'Я открыл дверь и отпрянул -- у порога, свернувшись, лежала змея. При моём появлении она подняла голову и зашипела.'
	end;
};

hu_snake = obj {
	nam = 'змея';
	-- константы состояний
	ST_UNSEEN = -1;		-- змею ещё не видел (дверь закрыта)
	ST_FREE = 0;		-- змея свободна (начальное)
	ST_UNDER_NET = 1;	-- я держу змею под сачком (руки заняты)
	ST_CAUGHT = 2;		-- змея поймана окончательно
	var {
		shots = 0,		-- выстрелов по змее
		state = -1		-- текущее состояние
	};
	dsc = function(s)
		if s.state == s.ST_FREE then
			p 'На пороге комнаты раскачивается {змея}.'
		elseif s.state == s.ST_UNDER_NET then
			p 'На пороге комнаты, пойманная моим сачком, {шевелится змея}.'
		elseif s.state == s.ST_CAUGHT then
			p 'В мешке шевелится пойманная {змея}.'
		end
	end;
	act = function(s) 
		if s.state == s.ST_FREE then
			p 'Я не рискну подойти к ней слишком близко!'
		elseif s.state == s.ST_UNDER_NET then
			p 'Долго я её так не удержу!'
		elseif s.state == s.ST_CAUGHT then
			p 'Теперь уж ей не вырваться!'
		end
	end;
	used = function(s, w)
		if s.state == s.ST_FREE then
			if w == revolver then
				if s.shots == 3 then
					return 'Может хватит уже тратить патроны впустую?!'
				end
				s.shots = s.shots + 1
				p 'Промах!'
			elseif w == insect_net then
				s.state = s.ST_UNDER_NET
				remove('insect_net', me())
				disable_balls()
				p 'Я изловчился и накинул на змею сачок.'
			elseif w == bag then
				p 'Накинуть мешок на змею -- мысль хорошая. Только прежде она десять раз успеет меня укусить!'
			end
		elseif s.state == s.ST_UNDER_NET then
			if w == bag then
				if bag.with_holes then
					p 'Ловить змею дырявым мешком? Я что, самоубийца!? (Это ошибка: сообщите разработчику!)'
				else
					s.state = s.ST_CAUGHT
					remove('bag', me())
					ways():add('cabinet')
					p 'Наступив на ручку сачка, я натянул сверху мешок, а потом крепко завязал его. Теперь уж змее не вырваться!'
				end
			else
				p 'У меня руки заняты.'
			end
		end
	end
};

hu_guns = obj {
	nam = 'ружья';
	dsc = 'На стене с рваными обоями висит пара {ружей}.';
	act = function(s)
		if hu_snake.state == hu_snake.ST_FREE then
			return 'Я не могу подойти к ружьям -- рядом змея!'
		elseif hu_snake.state == hu_snake.ST_UNDER_NET then
			return 'Я не могу разглядывать ружья, я держу змею.'
		else
			local st = 'Зачем мне разряженное ружьё? Надо сначала найти патроны.'
			if taken('revolver') then
				st = st..' Тем более, у меня уже есть револьвер.'
			end
			return st
		end
	end
};

-- НАБОЛДАШНИКИ
hu_balls = obj {
	nam = 'наболдашники';
	var {
		open = false		-- тайник открыт?
	};	
	dsc = 'Передо мной перила с изящными шарами-{наболдашниками}.';
	act = function(s)
		if hu_snake.state == hu_snake.ST_UNDER_NET then
			p 'Я не могу сейчас отвлекаться, я держу змею.'
		else
			p 'Да тут какие-то буквы -- это не спроста!'
			if disabled('hu_ball_1') then
				enable_balls()
			else
				disable_balls()
			end
		end
	end
};

-- повернуть s-ый шар и проверить код
function turn_ball_and_check(s, which)
	s.state = s.state + 1
	if s.state > #s.letters then s.state = 1 end
	p ('Я повернул '..which..' шар.')
--	if hu_balls.open then
--		p 'Тайник закрылся.'
--		if not taken('key_church') then
--			objs('house_upstairs'):del('key_church')
--		end
--	end
	hu_balls.open = false
	if hu_ball_1.state == 3 and 
	   hu_ball_2.state == 1 and 
	   hu_ball_3.state == 4 then
		disable_balls()
		disable('hu_balls')
		hu_balls.open = true
		objs('house_upstairs'):add('key_church')
		p 'Тайник открылся! Конечно же, "CAT"!'
	end
end

hu_ball_1 = obj {
	nam = 'левый шар';
	letters = {'A', 'B', 'C'};
	var {
		oiled = false,
		state = 1
	};
	dsc = function(s)
		return '^- {левый} шар (буква: '..s.letters[s.state]..')'
	end;
	act = function(s)
		if not s.oiled then
			return 'Шар заржавел и не хочет поворачиваться.'
		end
		turn_ball_and_check(s, 'левый')
	end;
	used = function(s, w)
		if w == body_oil and not s.oiled then
			s.oiled = true
			p 'Я смазал шар маслом для тела.'
		end
	end;
};

hu_ball_2 = obj {
	nam = 'средний шар';
	letters = {'A', 'I', 'U'};
	var {
		oiled = false,
		state = 1
	};
	dsc = function(s)
		return '^- {средний} шар (буква: '..s.letters[s.state]..')'
	end;
	act = function(s)
		if not s.oiled then
			return 'Шар заржавел и не хочет поворачиваться.'
		end
		turn_ball_and_check(s, 'средний')
	end;
	used = function(s, w)
		if w == body_oil and not s.oiled then
			s.oiled = true
			p 'Я смазал шар маслом для тела.'
		end
	end;
};

hu_ball_3 = obj {
	nam = 'правый шар';
	letters = {'P', 'R', 'S', 'T'};
	var {
		state = 3
	};
	dsc = function(s)
		return '^- {правый} шар (буква: '..s.letters[s.state]..')'
	end;
	act = function(s)
		turn_ball_and_check(s, 'правый')
	end
};

-- ВЕНТИЛЯЦИОННАЯ ШАХТА
hu_vent_mine = room {
	nam = 'Вентиляционная шахта';
	pic = function(s)
		if vm_lattice.open then
			if objs():srch('vent_mine_zodiak') then
				return 'gfx/house/upstairs/vent_mine/lattice_open.jpg'
			else
				return 'gfx/house/upstairs/vent_mine/zodiak_taken.jpg'
			end
		else
			return 'gfx/house/upstairs/vent_mine/0.jpg'
		end
	end;
	obj = { 
		'vm_lattice'
	};
	way = { 'house_upstairs' };
};

vm_lattice = obj {
	nam = 'решётка';
	var {
		open = false
	};
	dsc = function(s)
		if not s.open then
			p 'Вентиляционная шахта закрыта {решёткой}.' 
		else
			p 'Вентиляционная шахта открыта.' 
		end
	end;
	act = function(s)
		if not s.open then
			p 'В вентиляционной шахте что-то есть. Нужно снять решётку.'
		end
	end;
	used = function(s, w)
		if not s.open then
			if w == screwdriver then
				s.open = true
				objs():add('vent_mine_zodiak')
				p 'Я выкрутил винты и снял решётку.'
			elseif w == axe then
				p 'От удара решётка слегка погнулась, но не сломалась.'
			elseif w == scalpel then
				p 'Тут нужен другой инструмент.'
			end
		end
	end;
};

-- КАБИНЕТ
cabinet = room {
	nam = 'Кабинет';
	var {
		secret_door_opened = false
	};
	enter = function(s, from)
		if book_puzzle.solved and not s.secret_door_opened then
			s.secret_door_opened = true
			ways():del('cabinet_bookcase')
			ways():add('bedroom_ghost')
			objs():del('ca_knight')
			p 'Я услышал шум и повернул голову. Постамент с рыцарем отъехал в сторону, открыв секретный проход в соседнюю комнату.'
		end
	end;
	pic = function(s)
		local pict = 'gfx/house/cabinet/0.jpg'
		if ca_wood.with_disc then
			pict = pict..';gfx/house/cabinet/disc.jpg@363,249'
			if ca_globe.open then
				if taken('book_1904') then
					pict = pict..';gfx/house/cabinet/globe_open_book_taken.jpg@367,157'
				else 
					pict = pict..';gfx/house/cabinet/globe_open.jpg@370,157'
				end
			end
		end
		if s.secret_door_opened then
			pict = pict..';gfx/house/cabinet/door_open.jpg@0,53'
		end
		return pict
	end;
	dsc = [[
		Судя по всему, это кабинет хозяина дома.
		На стене висит портрет мужчины в цилиндре и сюртуке.
		Везде -- географические карты.
	]];
	obj = { 
		'ca_knight',
		vway('телескоп', 'Перед большим окном установлен {телескоп}.', 'cabinet_telescope'),
		'ca_window',
		vway('книга на качалке', 'В центре комнаты на кресло-качалке лежит раскрытая {книга}.', 'cabinet_book'),
		'ca_globe',
		'ca_wood',
	};
	way = { 'house_upstairs', 'cabinet_bookcase' };
};

ca_knight = obj {
	nam = 'железный рыцарь';
	dsc = 'Слева у стены стоит {железный рыцарь}.';
	act = 'Средневековый рыцарь в доспехах и с алебардой в руках.';
};

ca_window = obj {
	nam = 'окно на веранду';
	dsc = 'За окном на {веранде} виден черенок лопаты.';
	act = 'Дверь на веранду закрыта. Нужно найти ключ.';
};

ca_globe = obj {
	nam = 'глобус';
	var {
		open = false
	};
	dsc = 'На полу стоит огромный {глобус}.';
	act = 'Какой большой глобус! В детстве я мечтал о таком же!';
};

ca_wood = obj {
	nam = 'доска';
	var {
		with_disc = false
	};
	dsc = function(s)
		if not s.with_disc then
			p 'Сбоку к нему приделана {доска}.'
		else
			p 'Сбоку к нему приделана доска с солнечным {диском}.'
		end
	end;
	act = function(s)
		if not s.with_disc then
			p 'В доске имеется углубление необычной формы. Раньше там был вставлен какой-то предмет.'
		else
			if not ca_globe.open then
				ca_globe.open = true
				objs():add('book_1904')
				p 'Я нажал на диск, и верхняя часть глобуса отъехала вправо.'
			else
				p 'Хитрый тайник!'
			end
		end
	end;
	used = function(s, w)
		if w == sun and not s.with_disc then
			s.with_disc = true
			remove('sun', me())
			p 'Я вставил в углубление солнечный диск, и он на удивление точно подошёл.'
		end
	end
};

cabinet_telescope = room {
	nam = 'Телескоп';
	var {
		msg_one = true
	};
	pic = 'gfx/house/cabinet/moon.jpg';
	dsc = function(s)
		p_12(s, 'Как одинокая рыбка в пруду, скитается луна по небосводу.',
				'Полнолуние, однако...')
		p '^{back|Закрыть}'
	end;
	obj = { 
		xact('back', code[[goto('cabinet');]])
	};	
};

cabinet_book = room {
	nam = 'Книга';
	pic = 'gfx/house/cabinet/book.jpg';
	dsc = [[
		Скорее всего, хозяин дома увлекался гороскопами и хиромантией.
		^^
		{back|Закрыть}
	]];
	obj = { 
		xact('back', code[[goback();]])
	};	
};

-- КНИЖНЫЙ ШКАФ
cabinet_bookcase = room {
	nam = 'Книжный шкаф';
	pic = function(s)
		local pict = 'gfx/house/cabinet/bookcase/0.jpg'
		if not bookcase_zodiak.taken then
			pict = pict..';gfx/house/cabinet/bookcase/zodiak.jpg@244,238'
		end
		if cb_shelf.book_1898 then
			pict = pict..';gfx/house/cabinet/bookcase/book_1898.jpg@249,96'
		end
		if cb_shelf.book_1904 then
			pict = pict..';gfx/house/cabinet/bookcase/book_1904.jpg@353,96'
		end
		return pict
	end;
	dsc = 'В углу расположился книжный шкаф.';
	obj = {
		'cb_shelf',
		'bookcase_zodiak'
	};
	way = { 'cabinet' };
};

cb_shelf = obj {
	nam = 'полка';
	var {
		book_1898 = false,
		book_1904 = false
	};
	dsc = function(s)
		if s.book_1898 and s.book_1904 then
			p 'Все тома собраны, но {нужно сделать что-то ещё}!'
		else
			p 'Моё внимание привлекает средняя {полка}.'
		end
	end;
	act = function(s)
		if s.book_1898 and s.book_1904 then
			goto(book_puzzle)
		else
			p 'Солидные тома. Но тут явно чего-то не хватает!'
		end
	end;
	used = function(s, w)
		if w == book_1898 then
			if not bookcase_zodiak.taken then
				p 'Фишка с зодиаком мешает поставить том на место.'
			else
				s.book_1898 = true
				remove('book_1898', me())
				p 'Я поставил том на свободное место.'
			end
		elseif w == book_1904 then
			s.book_1904 = true
			remove('book_1904', me())
			p 'Я поставил том на свободное место.'
		end
	end;
};

-- СПАЛЬНЯ (одноразовая)
bedroom_ghost = room {
	nam = 'Спальня';
	pic = 'gfx/house/bedroom/ghost.jpg';
	hideinv = true;
	dsc = [[
		Прекрасная женщина лежит в кресле в своей спальне...
		^^ 
		{next|НЕ-Е-ЕТ!!!}
	]];
	obj = { 
		xact('next', 
			code[[
			ways(cabinet):replace(bedroom_ghost, bedroom);
			goto(bedroom);
			]])
	};
	exit = [[
		О, ЧЁРТ!!! Да что же, чёрт побери, тут творится?! 
		Нужно срочно бежать отсюда! Найти Энжел и бежать!
	]];
};

-- размер картинки 500х345 (по вертикали обрезано по 15 пикселов)
bedroom = room {
	nam = 'Спальня';
	pic = function(s)
		local pict = 'gfx/house/bedroom/0.jpg'
		if bd_bed.curtain_open then
			pict = pict..';gfx/house/bedroom/curtain_open.jpg@167,32'
		end
		return pict
	end;
	obj = { 
		'bd_corpse',
		'bd_cradle',
		'bd_bricks',
		'bd_bed',
		'cliche',
		'bd_inscriptions',
	};
	way = { 'cabinet', 'bedroom_window' };
};

bd_corpse = obj {
	nam = 'труп';
	dsc = 'В центре комнаты, в кресле лежит полуистлевший {труп женщины}.';
	act = 'Вот и пропавшая хозяйка дома... Не могу туда смотреть.';
};

bd_cradle = obj {
	nam = 'колыбелька';
	dsc = 'Слева стоит детская {колыбелька}.';
	act = 'Неужели она была беременна? Это ужасно!';
};

bd_bricks = obj {
	nam = 'проход';
	dsc = 'Проход в соседнюю комнату заложен {кирпичами}.'; 	--; среди кирпичей что-то блестит.';
	act = 'Боже, она была замурована здесь!';
};

bd_bed = obj {
	nam = 'кровать';
	var {
		curtain_open = false
	};
	dsc = function(s)
		p 'У дальней стены стоит двуспальная кровать; левая часть кровати {занавешена}.'
	end;
	act = function(s)
		if not s.curtain_open then
			s.curtain_open = true
			objs():del('bd_bed')
			ways():add('casket')
			p 'Я отодвинул занавеску в сторону и обнаружил на кровати шкатулку.';
		end
	end
};

bd_inscriptions = obj {
	nam = 'надписи';
	var {
		ind = 0
	};
	dsc = 'На ширме, на обоях, повсюду {надписи}.';
	act = function(s)
		local text = {
			[1] = '"День... Я нич... не понимаю. В доме ти... как будто все вым...ли. Что происходит?"',
			[2] = '"День 6. Я не могу докричаться до него, поче... он так жесток со мной? Почему??? Воды..."',
			[3] = '"День 3. Я чу...вую, как моя малышка умира... и я вместе с ней!" -- Какое-то безумие. Это всё похоже на страшный сон!',
		};
		s.ind = s.ind + 1
		if s.ind == 4 then s.ind = 1 end
		return text[s.ind];
	end
};

-- ОКНО СПАЛЬНИ
bedroom_window = room {
	nam = 'Окно';
	pic = function(s)
		local pict = 'gfx/house/bedroom/window/0.jpg'
		if bw_cat.broken then
			pict = 'gfx/house/bedroom/window/cat_broken.jpg'
			if not taken('money') then
				pict = pict..';gfx/house/bedroom/window/money.jpg@161,291'
			end
		end
		if not taken('pendant_1') then
			pict = pict..';gfx/house/bedroom/window/pendant.jpg@55,186'
		end
		return pict
	end;
	dsc = 'Окно забрано толстыми решётками.';
	obj = {
		'bw_glass',
		'bw_cat',
		'pendant_1'
	};
	way = { 'bedroom' };
};

bw_glass = obj {
	nam = 'стёкла';
	dsc = '{Стёкла} выбиты наружу.';
	act = 'Их разбила женщина, пытаясь докричаться хоть до кого-то.';
};

bw_cat = obj {
	nam = 'кошка';
	var {
		broken = false
	};
	dsc = 'На подоконнике стоит фаянсовое изваяние {кошки}.';
	act = 'Внутри неё что-то звякает!';
	used = function(s, w)
		if w == hammer and not s.broken then
			s.broken = true
			objs():del('bw_cat')
			objs():add('money')
			p 'Несколько ударов, и от изваяния остались одни осколки.'
		end
	end
};

-- ШКАТУЛКА
casket = room {
	nam = 'Шкатулка';
	var {
		open = false
	};
	enter = function(s, from)
		if casket_puzzle.solved and not s.open then
			s.open = true
			objs():add('paper')
			objs():add('ca_diary')
		end
	end;
	pic = function(s)
		local pict = 'gfx/house/bedroom/casket/0.jpg'
		if s.open then
			pict = 'gfx/house/bedroom/casket/open.jpg'
			if taken('paper') then
				pict = pict..';gfx/house/bedroom/casket/paper_taken.jpg@103,195'
			end
			if ca_diary.cnt == 1 then
				pict = pict..';gfx/house/bedroom/casket/pendant_1.jpg@248,203'
			elseif ca_diary.cnt == 2 then
				pict = pict..';gfx/house/bedroom/casket/nolock.jpg@240,200'
			end
		end
		return pict
	end;
	obj = { 
		'ca_lock'
	};
	way = { 'bedroom' };
};

ca_lock = obj {
	nam = 'замок шкатулки';
	dsc = function(s)
		if not casket.open then
			p 'Передо мной лежит резная деревянная шкатулка. Простой {механизм с секретом} закрывает её.'
		else
			pr 'В шкатулке, обитой зелёным бархатом, лежат бирюзовые серьги'
		end
	end;
	act = function(s)
	   goto(casket_puzzle)
	end;
};

ca_diary = obj {
	nam = 'дневник Марии';
	var {
		cnt = 0		-- кол-во вставленных половинок кулона (0, 1, 2)
	};
	dsc = function(s)
		if s.cnt < 2 then
			p 'и пухлый дневник с {защёлкой} в виде сердечка.'
		else
			p 'и пухлый {дневник}.'
		end
	end;
	act = function(s)
		if s.cnt < 2 then
			p 'Что-то мне не хочется ломать защёлку. Не думаю, что это понравилось бы хозяйке дневника.'
		else
			goto(maria_diary)
		end
	end;
	used = function(s, w)
		if w == pendant_1 or w == pendant_2 then
			s.cnt = s.cnt + 1
			remove(w, me())
			if s.cnt == 1 then
				p 'Я вставил половинку кулона в защёлку. Нужна ещё половинка. У кого же она? Сомневаюсь, что она была у того мужчины, чей портрет в кабинете.'
			elseif s.cnt == 2 then
				p 'Я вставил вторую половинку кулона. Защёлка открылась.'
			end
		end
	end
};

-- ДНЕВНИК МАРИИ де ла Круз
maria_diary = room {
	var {
		page = 5,	-- 5 - страница с картинкой витража в церкви
		seen = false
	};
	nam = 'Дневник Марии';
	enter = function(s)
		s.seen = true
	end;
	pic = function(s)
		return 'gfx/maria_diary/'..tostring(s.page)..'.jpg'
	end;
	dsc = 'Движимый не любопытством, а желанием узнать правду, открыл я дневник погибшей женщины...';
	obj = { 
		vobj('prev', '{< назад} . . .'),
		vobj('next', '{вперёд >}'),
		vway('exit', '^^{Закрыть}', 'casket'),
	};
	act = function(s, w)
		if w == 'prev' then
			if s.page > 1 then 
				s.page = s.page - 1
			end
		elseif w == 'next' then
			if s.page < 16 then 
				s.page = s.page + 1 
			end
		end
		return 'страница: '..tostring(s.page)
	end;
};

