-- МИНИ-ИГРА СЕЙФ (менять попарно, соединить голубые и желтые полосы)
-- Вход и выход: комната rebecca_cabin
-- При успешном решении устанавливает safe_puzzle.solved = true

-- количество клеток
local CNT_CELLS = 16
-- координаты левого-верхнего угла клеток
local LEFT_X = {196, 126,  56, 266, 196, 126,  56, 266, 126, 336, 266, 196, 126, 336, 266, 196}
local TOP_Y  = { 36,  74, 112,  74, 112, 150, 189, 150, 227, 189, 227, 265, 303, 265, 303, 341}
-- размер клетки в пикселах
local CELL_X = 92
local CELL_Y = 76

-- массив sf_board[ CNT_CELLS ], индексы с 1
-- содержит индексы фишек (1..10), 0 - если пустая
-- сохраняется в save-файле
global {
	sf_board = {1, 2, 0, 0, 3, 0, 4, 0, 5, 6, 7, 0, 8, 9, 10, 0}
}

local pic_name = {
	[0] = 'gfx/safe_puzzle/empty.png',
	[1] = 'gfx/safe_puzzle/1.png',
	[2] = 'gfx/safe_puzzle/2.png',
	[3] = 'gfx/safe_puzzle/3.png',
	[4] = 'gfx/safe_puzzle/4.png',
	[5] = 'gfx/safe_puzzle/5.png',
	[6] = 'gfx/safe_puzzle/6.png',
	[7] = 'gfx/safe_puzzle/7.png',
	[8] = 'gfx/safe_puzzle/8.png',
	[9] = 'gfx/safe_puzzle/9.png',
	[10] ='gfx/safe_puzzle/10.png',
}

local function draw_board(s)
	local i, fname
	local pict = 'gfx/safe_puzzle/_board.jpg'
	for i = 1, CNT_CELLS do
		fname = pic_name[ sf_board[i] ]
		pict = pict..';'..fname..'@'..LEFT_X[i]..','..TOP_Y[i]
	end		 
	if s.sel ~= 0 then
		pict = pict..';gfx/safe_puzzle/frame.png@'..LEFT_X[s.sel]..','..TOP_Y[s.sel]
	end
	if s.solved then
		pict = pict..';gfx/safe_puzzle/solved.png@88,300'
	end
	return pict
end

-- если (x,y) не принадлежат полю, возвращает 0, иначе индекс места (1..16)
local function select_piece(x, y)
	for i = 1, CNT_CELLS do
		if (x >= LEFT_X[i]) and (x < LEFT_X[i] + CELL_X - 3) and 
		   (y >= TOP_Y[i])  and (y < TOP_Y[i]  + CELL_Y) then
			return i
		end
	end
--	print('click pos: '..x..', '..y..'   selected: '..ix)
	return 0
end

local function swap_pieces(i, j)
	local tmp = sf_board[i]
	sf_board[i] = sf_board[j]
	sf_board[j] = tmp
end

local function check_for_sol()
	local sol = {4, 0, 5, 0, 7, 8, 0, 1, 3, 0, 2, 6, 0, 9, 0, 10}
	for i = 1, CNT_CELLS do
    	if sf_board[i] ~= sol[i] then
    		return false
		end
	end
	return true
end


-- КОМНАТА
safe_puzzle = room {
	nam = 'Мини-игра Сейф';
	hideinv = true;
	var {
		solved = false,  -- головоломка решена?
		sel = 0		 	-- индекс выбранного клетки (1..16, 0=не выбрана)
	};
	enter = function(s)
		-- всегда снимает предыдущее выделение поля
		s.sel = 0
	end;
	pic = function(s)
		return draw_board(s)
	end;
	click = function(s, x, y)
		-- требуется ещё 1 клик, чтобы выйти из мини-игры после решения!
		if s.solved then
			goto('rebecca_cabin')
		end
		local p = select_piece(x, y)
		if p ~= 0 then
			if s.sel == 0 then
				s.sel = p
			elseif p ~= s.sel then
				swap_pieces(p, s.sel)
				s.sel = 0
				if check_for_sol() then
					s.solved = true
					print('Safe puzzle solved!')
				end
			end
			return true  -- перерисовывает сцену!
		end
	end;
	obj = { 
		vway('exit', 
			'Меняя фишки местами, соедините голубые и жёлтые полоски.^{Выйти}', 
			'rebecca_cabin')
	};
};
